/*
 * @author Gabriel Balestrin
 */
package Commands;

public abstract class AbstractInstruction implements Instruction {

    protected Instruction nextInstruction;
    protected int line;

    public void setNext(Instruction next) {
        this.nextInstruction = next;
    }

    public Instruction executeSimulation(BlockContext inThisContext) {
        // Just simulate a execution
        return nextInstruction;
    }

    public int getLine() {
        return line;
    }

    /* Method used by commands GP, GC, GL, GS
     * If user set the approach
     */
    public void setApproach(BlockContext inThisContext, int approach, int line) {
        switch (approach) {
            case 1://FREE

                break;
            case 2://FRONT
                if ((90 - (inThisContext.getScene().getBeta() + inThisContext.getScene().getGama())) <= 130 && (90 - (inThisContext.getScene().getBeta() + inThisContext.getScene().getGama())) >= -130) {
                    inThisContext.getScene().setElevacao(90 - (inThisContext.getScene().getBeta() + inThisContext.getScene().getGama()));
                } else {
                    inThisContext.informWarning(ErrorMessages.WARNING_APPROACH, line, "FRONT");
                }
                break;
            case 3: //UP
                if ((180 - (inThisContext.getScene().getBeta() + inThisContext.getScene().getGama())) <= 130 && (180 - (inThisContext.getScene().getBeta() + inThisContext.getScene().getGama())) >= -130) {
                    inThisContext.getScene().setElevacao(180 - (inThisContext.getScene().getBeta() + inThisContext.getScene().getGama()));
                } else {
                    inThisContext.informWarning(ErrorMessages.WARNING_APPROACH, line, "UP");
                }
                break;
            case 4: //FIXED
                float anguloGarra = inThisContext.getScene().getElevacao() + inThisContext.getScene().getBeta() + inThisContext.getScene().getGama();
                if ((anguloGarra - (inThisContext.getScene().getBeta() + inThisContext.getScene().getGama())) <= 130 && (anguloGarra - (inThisContext.getScene().getBeta() + inThisContext.getScene().getGama())) >= -130) {
                    inThisContext.getScene().setElevacao(anguloGarra - (inThisContext.getScene().getBeta() + inThisContext.getScene().getGama()));
                } else {
                    inThisContext.informWarning(ErrorMessages.WARNING_APPROACH, line, "FIXED");
                }
                break;
            case 5: //BACK
                if ((-90 - (inThisContext.getScene().getBeta() + inThisContext.getScene().getGama())) <= 130 && (-90 - (inThisContext.getScene().getBeta() + inThisContext.getScene().getGama())) >= -130) {
                    inThisContext.getScene().setElevacao(-90 - (inThisContext.getScene().getBeta() + inThisContext.getScene().getGama()));
                } else {
                    inThisContext.informWarning(ErrorMessages.WARNING_APPROACH, line, "BACK");
                }
                break;

        }
    }
}
