/*
 * @author Gabriel Balestrin
 */
package Commands;

public abstract class ErrorMessages {

    /*Language*/
    final static int PORTUGUESE = 1;
    final static int ENGLISH = 2;



    /* SEMANTIC ERROR MESSAGE */
    final static int ERROR_SCENE = 1;
    final static int ERROR_SUBROUTINE = 2;
    final static int ERROR_POINTLIST = 3;
    final static int ERROR_POINTSEQUENCE = 4;
    final static int ERROR_POINTPOSITION = 5;
    final static int ERROR_NOTVARIABLE = 6;
    final static int ERROR_POINTOPERATOR = 7;
    final static int ERROR_LABEL = 8;
    final static int WARNING_POINTDEFINED = 9;
    final static int WARNING_AXISX = 10;
    final static int WARNING_AXISY = 11;
    final static int WARNING_AXISZ = 12;
    final static int WARNING_APPROACH = 13;
    final static int ERROR_IL_AXIS = 14;
    final static int ERROR_INPUT = 15;
    final static int ERROR_GLINVALID = 16;
    final static int ERROR_POINT_NUMBER_GS = 17;
    final static int ERROR_POINT_NOT_DEFINED = 18;
    final static int ERROR_MULTIPLES_LABEL = 19;
    final static int ERROR_APPROACH = 20;
    final static int ERROR_POINT_CONTROL = 21;
    final static int ERROR_POINT_GSM = 22;



    public static String getMessage(int message, int lineError, int language, String complements) {
        String pt = "ERRO na linha " + lineError + ": ";
        String en = "ERROR line " + lineError + ": ";
        String ptW = "AVISO na linha " + lineError + ": ";
        String enW = "WARNING line " + lineError + ": ";

        switch (message) {

            case ERROR_SCENE:
                if(language == PORTUGUESE)
                    return pt + "Cena não encontrada!";
                else
                    return en + "Scene not found!";
            case ERROR_SUBROUTINE:
                if(language == PORTUGUESE)
                    return pt + "Subrotina '" + complements + "' não encontrada!";
                else
                    return en + "Subroutine '" + complements + "' not found!";
            case ERROR_POINTLIST:
                if(language == PORTUGUESE)
                    return pt + "Lista de pontos não exite!";
                else
                    return en + "Point List not exist!";
            case ERROR_POINTSEQUENCE:
                if(language == PORTUGUESE)
                    return pt + "Sequencia de pontos " + complements + " não existe!";
                else
                    return en + "Point sequence " + complements + " not exists!";
            case ERROR_POINTPOSITION:
                if(language == PORTUGUESE)
                    return pt + "Posição '" + complements + "' não existe!";
                else
                    return en + "Position '" + complements + "' not exists!";
            case ERROR_NOTVARIABLE:
                if(language == PORTUGUESE)
                    return pt + "Variavel '" + complements + "' não definida!";
                else
                    return en + "Variable '" + complements + "' not declared!";
            case ERROR_POINTOPERATOR:
                if(language == PORTUGUESE)
                    return pt + "No operador Ponto(.). Selecione o eixo correto[X,Y,Z]!";
                else
                    return en + "Point operator(.).Select the correct axis [X,Y,Z]!";
            case ERROR_LABEL:
                if(language == PORTUGUESE)
                    return pt + "Label '" + complements + "' não encontrado!";
                else
                    return en + "Label '" + complements + "' not found!";
            case WARNING_POINTDEFINED:
                if(language == PORTUGUESE)
                    return ptW + "Posição '" + complements + "' já definida, posição não pode ser salva!\n";
                else
                    return enW + "Position '" + complements + "' alredy defined, the position can't be saved!\n";
            case WARNING_AXISX:
                if(language == PORTUGUESE)
                    return ptW + "Valor '"+complements+"' é o limite para o eixo X!\n";
                else
                    return enW + "Value '" + complements + "' is the limit for the X axis!\n";
            case WARNING_AXISY:
                if(language == PORTUGUESE)
                    return ptW + "Valor '"+complements+"' é o limite para o eixo Y!\n";
                else
                    return enW + "Value '" + complements + "' is the limit for the Y axis!\n";
            case WARNING_AXISZ:
                if(language == PORTUGUESE)
                    return ptW + "Valor '"+complements+"' é o limite para o eixo Z!\n";
                else
                    return enW + "Value '" + complements + "' is the limit for the Z axis!\n";
            case WARNING_APPROACH:
                if(language == PORTUGUESE)
                    return ptW + "Abordagem '"+complements+"' não é suportada whhy??!\n";
                else
                    return enW + "Approach '" + complements + "' isn't supported!\n";
            case ERROR_IL_AXIS:
                if(language == PORTUGUESE)
                    return pt + "Eixo '"+complements+"' não existe. Eixos existentes [1,2,3,4,5]!";
                else
                    return en + "Axis '" + complements + "' not found. Founded axes [1,2,3,4,5]!";
            case ERROR_INPUT:
                if(language == PORTUGUESE)
                    return pt + "Entrada '"+complements+"' não existe. Entradas existentes [1,2,3,4,5,6,7,8]!";
                else
                    return en + "Input '" + complements + "' not found. Founded Inputs [1,2,3,4,5,6,7,8]!";
            case ERROR_GLINVALID:
                if(language == PORTUGUESE)
                    return pt + "Ponto '"+complements+"' não é possível alcançar!";
                else
                    return en + "Point '" + complements + "' isn't reachable!";
            case ERROR_POINT_NUMBER_GS:
                if(language == PORTUGUESE)
                    return pt + "O número de pontos é menor que 4!";
                else
                    return en + "The number of points is less than 4!";
            case ERROR_POINT_NOT_DEFINED:
                if(language == PORTUGUESE)
                    return pt + "Posição '"+complements+"' não definida!";
                else
                    return en + "Position '"+complements+"' isn't defined!";
            case ERROR_MULTIPLES_LABEL:
                if(language == PORTUGUESE)
                    return pt + "Label '"+complements+"' possui multiplas definições!";
                else
                    return en + "Label '"+complements+"' there are many definitions!";
            case ERROR_APPROACH:
                if(language == PORTUGUESE)
                    return pt + "Abordagem "+complements+"inixistente. Esperando : [FREE, FIXED, UP, BACK, FRONT]!";
                else
                    return en + "Approach "+complements+"not found. Waiting : [FREE, FIXED, UP, BACK, FRONT]!";
            case ERROR_POINT_CONTROL:
                if(language == PORTUGUESE)
                    return pt + "Ponto de Controle '"+complements+"' inixistente. Ver lista Pontos de Controle!";
                else
                    return en + "Control Point '"+complements+"' not found. See control point list!";
            case ERROR_POINT_GSM:
                if(language == PORTUGUESE)
                    return pt + "Posição "+complements+"não alcançada pela cinemática inversa.\n Movimentação cancelada!";
                else
                    return en + "Position "+complements+"isn't reachable by Inverse Kinematics. Canceled move!";
        }

        return "";
    }
}
