/*
 * @author Gabriel Balestrin
 */
package Commands;

import Componentes.RList;
import Robo.Angulos;
import Robo.Ponto;
import java.util.ArrayList;
import virbot4u.JanelaPonto;

public class InstrGC extends AbstractInstruction {

    private String positionVia;
    private String positionF;
    private RList lPontos;
    private int approach;

    public InstrGC(String positionVia, String positionF, int approach, int line) {
        this.positionVia = positionVia;
        this.positionF = positionF;
        this.line = line;
        this.approach = approach;
    }

    public Instruction execute(BlockContext inThisContext) {
        int endPoint = -1, viaPoint = -1;
        float granularidade = inThisContext.getScene().granularity;
        float x, y, z;
        float u = 1 / granularidade;
        float roll, pitch;
        Angulos ang;
        ArrayList angs, points = null;
        float x1,x2,y1,y2,z1,z2;
        int sleep;
        // initializing
        x1=x2=y1=y2=z1=z2=0;

        /* Recupera lista de Pontos */
        lPontos = JanelaPonto.getListaDePontos();
        if (lPontos == null) {
            inThisContext.informError(ErrorMessages.ERROR_POINTLIST, line, "");
        }

        /* Looking for the right variable*/
        if (!Character.isDigit(positionF.charAt(0))) {
            endPoint = inThisContext.verificaPontos(positionF,line);
        } else {
            endPoint = Integer.parseInt(positionF) - 1;
        }
        if (!Character.isDigit(positionVia.charAt(0))) {
            viaPoint = inThisContext.verificaPontos(positionVia,line);
        } else {
            viaPoint = Integer.parseInt(positionVia) - 1;
        }

        /* If end position not exist */
        if (endPoint == -1 || endPoint > lPontos.getItemCount() - 1) {
            inThisContext.informError(ErrorMessages.ERROR_POINTPOSITION, line, (endPoint == -1 ? positionF : ""));
        }
        /* If via position not exist */
        if (viaPoint == -1 || viaPoint > lPontos.getItemCount() - 1) {
            inThisContext.informError(ErrorMessages.ERROR_POINTPOSITION, line, (viaPoint == -1 ? positionVia : ""));
        }

        // point list of interpolations points
        points = new ArrayList();


        /* Parametric Equations of a Curve
         * p(u)= (2u^2 - 3u +1)p0 + (-4u^2 +4u)p0.5 + (2u^2 -u)p1
         */

        if (inThisContext.getScene() == null) {
            inThisContext.informError(ErrorMessages.ERROR_SCENE, line, "");
        } else {
            //APROACH move
            this.setApproach(inThisContext, approach, line);
            try {Thread.sleep(35);} catch (InterruptedException e) {}
            for (int p = 0; p <= granularidade; p++) {
                x = (2 * (float) Math.pow((u * p), 2) - 3 * (u * p) + 1) * inThisContext.getScene().getPontoX()
                        + (-4 * (float) Math.pow((u * p), 2) + 4 * (u * p)) * ((Ponto) lPontos.getObjeto(viaPoint)).getX()
                        + (2 * (float) Math.pow((u * p), 2) - (u * p)) * ((Ponto) lPontos.getObjeto(endPoint)).getX();

                y = (2 * (float) Math.pow((u * p), 2) - 3 * (u * p) + 1) * inThisContext.getScene().getPontoY()
                        + (-4 * (float) Math.pow((u * p), 2) + 4 * (u * p)) * ((Ponto) lPontos.getObjeto(viaPoint)).getY()
                        + (2 * (float) Math.pow((u * p), 2) - (u * p)) * ((Ponto) lPontos.getObjeto(endPoint)).getY();

                z = (2 * (float) Math.pow((u * p), 2) - 3 * (u * p) + 1) * inThisContext.getScene().getPontoZ()
                        + (-4 * (float) Math.pow((u * p), 2) + 4 * (u * p)) * ((Ponto) lPontos.getObjeto(viaPoint)).getZ()
                        + (2 * (float) Math.pow((u * p), 2) - (u * p)) * ((Ponto) lPontos.getObjeto(endPoint)).getZ();
                //get first point
                if (p == 0) {
                    x1 = x;
                    y1 = y;
                    z1 = z;
                }
                //get last point
                if (p == granularidade/2) {
                    x2 = x;
                    y2 = y;
                    z2 = z;
                }
                pitch = inThisContext.getScene().toRadianos(inThisContext.getScene().getElevacao() + inThisContext.getScene().getBeta() + inThisContext.getScene().getGama()) - (float) Math.PI;
                roll = inThisContext.getScene().toRadianos(inThisContext.getScene().getRotacao());

                angs = inThisContext.getScene().calcularInversaPontos(-x, z, y, pitch, roll, true);
                if (angs == null) {
                    inThisContext.informError(ErrorMessages.ERROR_GLINVALID, line, positionF);
                }
                ang = new Angulos(inThisContext.getScene().toGraus((Float) angs.get(0)), inThisContext.getScene().toGraus((Float) angs.get(1)), inThisContext.getScene().toGraus((Float) angs.get(2)), inThisContext.getScene().toGraus((Float) angs.get(3)), inThisContext.getScene().toGraus((Float) angs.get(4)));
                points.add(ang);
            }
                                                             // ________________________
            //point distance between first and last point d = |/ (x2-x1)+(y2-y1)+(z2-z1)
            double distance = Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y1 - y2, 2) + Math.pow(z1 - z2, 2));
            sleep = (int) (granularidade * distance) / 700;
            
            for (int p = 0; p <= granularidade; p++) {
                inThisContext.getScene().setAngulos((Angulos) points.get(p));
                try {Thread.sleep(sleep);} catch (InterruptedException e) {}
            }
        }
        return nextInstruction;
    }

}
