/*
 * @author Gabriel Balestrin
 */
package Commands;

import Componentes.RList;
import Robo.Angulos;
import Robo.Ponto;
import java.util.ArrayList;
import virbot4u.JanelaPonto;
public class InstrGP extends AbstractInstruction {

    private RList lPontos;
    private ArrayList position;
    private int approach;

    
    public InstrGP(ArrayList position, int approach, int line) {
        this.position = position;
        this.line = line;
        this.approach = approach;
    }

    public Instruction execute(BlockContext inThisContext) {
        Ponto pnt = null;
        int cont;

        /* Get point List */
        lPontos = JanelaPonto.getListaDePontos();
        if(lPontos == null){
            inThisContext.informError(ErrorMessages.ERROR_POINTLIST,line,"");
        }

        /*GP p1...3 --> [p1, 3, #]*/
        if(position.size() == 3 && position.get(2).equals("#")){
            int cont1, cont2;
            String pointName1, pointName2;
            pointName1 = position.get(0).toString();
            pointName2 = position.get(1).toString();

            /* Remove the last point and the simbol '#'*/
            position.remove(2);
            position.remove(1);

            /* Looking for the right variable*/
            if(!Character.isDigit(pointName1.charAt(0))){
                cont1 = inThisContext.verificaPontos(pointName1,line);
            }
            else{
                cont1 = Integer.parseInt(pointName1)-1;
            }
            if(!Character.isDigit(pointName2.charAt(0))){
                cont2 = inThisContext.verificaPontos(pointName2,line);
            }
            else{
                cont2 = Integer.parseInt(pointName2)-1;
            }

            if(cont1>cont2){
                inThisContext.informError(ErrorMessages.ERROR_POINTSEQUENCE,line,pointName1+" ... "+pointName2);
            }

            for(int i=cont1+1;i<=cont2;i++){
                position.add( ((Ponto)lPontos.getObjeto(i)).getNomePonto());
            }

            position.add(pointName2);
        }
        String pointName;
        for (int i = 0; i < position.size(); i++) {
            // calculate angule approach gripper
            this.setApproach(inThisContext, approach, line);
            try { Thread.sleep(35); } catch (InterruptedException e) {}

            if(position.get(i).toString().length()>0)
            {
                pointName = position.get(i).toString();
                /* If point name, else index of list*/
                if(!Character.isDigit(pointName.charAt(0))){
                    cont = inThisContext.verificaPontos(pointName,line);
                }
                else{
                    cont = Integer.parseInt(pointName)-1;
                }
                if(cont == -1 || cont > lPontos.getItemCount()-1){
                    inThisContext.informError(ErrorMessages.ERROR_POINTPOSITION,line,(cont== -1? position.get(i).toString()+" ": ""));
                }
                pnt = (Ponto) lPontos.getObjeto(cont);

                if(inThisContext.getScene() == null){
                    inThisContext.informError(ErrorMessages.ERROR_SCENE,line,"");
                }else{
                    if(approach == 0 || approach == 1){ //Approach == none or FREE
                        inThisContext.getScene().setMove(pnt.getAngulos());
                    }else{
                        inThisContext.getScene().setMove(new Angulos(pnt.getAlfa(),pnt.getBeta(), pnt.getGama(), definePositionApproach(inThisContext,  pnt,  approach, line),pnt.getRotacao()));
                    }
                }
            }
            try { Thread.sleep(1000);} catch (InterruptedException e) {}
        }

        return nextInstruction;
    }



        
        public float definePositionApproach(BlockContext inThisContext, Ponto pnt, int approach, int line){
            float valApproach;
            switch(approach){
                case 1://FREE

                break;
                case 2://FRONT
                    if((90-(pnt.getBeta()+pnt.getGama()))<=130 && (90-(pnt.getBeta()+pnt.getGama()))>=-130)
                        return 90-(pnt.getBeta()+pnt.getGama());
                    else{
                        inThisContext.informWarning(ErrorMessages.WARNING_APPROACH,line,"FRONT");
                    }
                break;
                case 3: //UP
                    if((180-(pnt.getBeta()+pnt.getGama()))<=130 && (180-(pnt.getBeta()+pnt.getGama()))>=-130)
                        return 180-(pnt.getBeta()+pnt.getGama());
                    else{
                        inThisContext.informWarning(ErrorMessages.WARNING_APPROACH,line,"UP");
                    }
                break;
                case 4: //FIXED
                    // calculate approach fixed
                    float anguloGarra = inThisContext.getScene().getElevacao()+inThisContext.getScene().getBeta()+inThisContext.getScene().getGama();
                    if((anguloGarra-(pnt.getBeta()+pnt.getGama()))<=130 && (anguloGarra-(pnt.getBeta()+pnt.getGama()))>=-130){
                        valApproach = inThisContext.getScene().toRadianos(pnt.getElevacao()+pnt.getBeta()+pnt.getGama()) - (float)Math.PI;
                        return anguloGarra-(pnt.getBeta()+pnt.getGama());
                    }else{
                        inThisContext.informWarning(ErrorMessages.WARNING_APPROACH,line,"FIXED");
                    }
                break;
                case 5: //BACK
                    if((-90-(pnt.getBeta()+pnt.getGama()))<=130 && (-90-(pnt.getBeta()+pnt.getGama()))>=-130)
                        return -90-(pnt.getBeta()+pnt.getGama());
                    else{
                        inThisContext.informWarning(ErrorMessages.WARNING_APPROACH,line,"BACK");
                    }
                break;

            }
            return 150; // limites da elevação são -130 a 130
        }



}
