/*
 * @author Gabriel Balestrin
 */
package Commands;

public class InstrIF extends AbstractInstruction {

    private Nodo condition;
    private String toLabel;

        public InstrIF(Nodo condition, String toLabel, int line){
            this.condition = condition;
            this.toLabel = toLabel;
            this.line = line;
        }

	public Instruction execute(BlockContext inThisContext) {
		System.out.println("IF "+toLabel);
                float cond = condition.value(inThisContext, line);

                if(cond == -1)
                    System.out.println("ERRO IF");
                else if(cond == 0){
                    /* If label isn't defined */
                    if(inThisContext.getInstrForLabel(toLabel) == null){
                         inThisContext.informError(ErrorMessages.ERROR_LABEL,line,toLabel);
                    }
                    return inThisContext.getInstrForLabel(toLabel);
                }
		return nextInstruction;

	}
}
