package Commands;

public class InstrIL extends AbstractInstruction {

    private Nodo axis;
    private String toLabel;

        public InstrIL(Nodo axis, String toLabel, int line){
            this.axis = axis;
            this.toLabel = toLabel;
            this.line = line;
        }

	public Instruction execute(BlockContext inThisContext) {
		System.out.println("IL "+toLabel);
                float cond = axis.value(inThisContext, line);
                int aux =0;

                /* If axis is diferent that [0,1,2,3,4,5]*/
                if(cond<0 || cond>5){
                   inThisContext.informError(ErrorMessages.ERROR_IL_AXIS,line,axis.getData());
                }
                else{
                    // BASE
                    if(cond == 1 || cond == 0){
                        float base = inThisContext.getScene().getAlfa();
                        if(base <= 10 || base >= 300){
                            aux = 1;
                        }
                        //System.out.println("Alfa"+inThisContext.getScene().getAlfa());

                    }// BRACO
                    if(cond == 2 || cond == 0){
                        float braco = inThisContext.getScene().getBeta();
                        if(braco <= -25 || braco >= 120){
                            aux = 1;
                        }
                        //System.out.println("Beta"+inThisContext.getScene().getBeta());

                    }// ANTEBRACO
                    if(cond == 3 || cond == 0){
                        //System.out.println("Gama"+inThisContext.getScene().getGama());
                        float antebraco = inThisContext.getScene().getGama();
                        if(antebraco <= -120 || antebraco >= 120){
                            aux = 1;
                        }
                    }// ELEVACAO
                    if(cond == 4 || cond == 0){
                        //System.out.println("Elevacao"+inThisContext.getScene().getElevacao());
                        float elevacao = inThisContext.getScene().getElevacao();
                        if(elevacao <= -120 || elevacao >= 120){
                            aux = 1;
                        }
                    }// ROTACAO
                    if(cond == 5 || cond == 0){
                        //System.out.println("Rotacao"+inThisContext.getScene().getRotacao());
                        float rotacao = inThisContext.getScene().getRotacao();
                        if(rotacao <= -568 || rotacao >= 568){
                            aux = 1;
                        }
                    }
                }
                /* If there is no label*/
                if(inThisContext.getInstrForLabel(toLabel) == null){
                    inThisContext.informError(ErrorMessages.ERROR_LABEL,line,toLabel);
                }else if(aux == 0){
                    return inThisContext.getInstrForLabel(toLabel); // Keep execution
                }
		return nextInstruction;//Jump to label
        }
	
}
