/*
 * @author Gabriel Balestrin
 */
package Commands;

import virbot4u.JanelaDigital;

public class InstrOI extends AbstractInstruction {

    private Nodo ioToken;
    private String toLabel;
    private boolean onOff;
    private float input;

    public InstrOI(Nodo ioToken, boolean onOff, String toLabel, int line) {
        this.ioToken = ioToken;
        this.toLabel = toLabel;
        this.onOff = onOff;
        this.line = line;
    }

    public Instruction execute(BlockContext inThisContext) {
        System.out.println("IO " + toLabel);
        input = 0;

        if (ioToken.getData().equals("ANY")) {
        }
        else {
            input = ioToken.value(inThisContext, line);
        }

        System.out.println(nextInstruction.getLine());

        // 0 ANY, 1,...,8 Inputs
        if (input == 0 || input == 1 || input == 2 || input == 3 || input == 4 || input == 5 || input == 6 || input == 7 || input == 8) {
            /* Create a interruption and execute it*/
            Interruption interrupt = new Interruption(inThisContext);
            interrupt.start();
        } else {
            inThisContext.informError(ErrorMessages.ERROR_INPUT, line, "" + input);
        }

        //keep the execution
        return inThisContext.getInstrForLabel(toLabel);

    }

    public class Interruption extends Thread {

        private BlockContext inThisContext;

        public Interruption(BlockContext inThisContext) {
            this.inThisContext = inThisContext;
        }

        public void run() {
                System.out.println("Interrupt up!");
                int contr=0;
                if(input == 0){
                    while(true){
                        
                        /* If is end of the compilation */
                        if(inThisContext.isAlive()==false) break;
                        if(JanelaDigital.getInput(1,onOff).isSelected() == true
                           ||JanelaDigital.getInput(2,onOff).isSelected() == true
                           ||JanelaDigital.getInput(3,onOff).isSelected() == true
                           ||JanelaDigital.getInput(4,onOff).isSelected() == true
                           ||JanelaDigital.getInput(5,onOff).isSelected() == true
                           ||JanelaDigital.getInput(6,onOff).isSelected() == true
                           ||JanelaDigital.getInput(7,onOff).isSelected() == true
                           ||JanelaDigital.getInput(8,onOff).isSelected() == true){
                            contr++;
                            inThisContext.setInterruption(true,(int)input, nextInstruction,line,contr);

                        }
                        else
                            contr = 0;
                    }
                }else{
                    while(true){
                        if(inThisContext.isAlive()==false) break;
                        if(JanelaDigital.getInput((int)input,onOff).isSelected() == true){
                            contr++;
                            inThisContext.setInterruption(true,(int)input, nextInstruction,line,contr);
                        }
                        else
                            contr = 0;
                    }
                }
        }

     }
}
