/*
 * @author Gabriel Balestrin
 */
package Commands;

import Robo.Ponto;
import java.util.ArrayList;
import virbot4u.JanelaPonto;


public class InstrSVC extends AbstractInstruction {

        private Nodo variable;
        private Nodo no;
        private Float value;
        private int pnt;

        public InstrSVC(Nodo variable, Nodo no, int line){
            this.no = no;
            this.variable = variable;
            this.line = line;
        }

	public Instruction execute(BlockContext inThisContext) {
                System.out.println(no.getData());
                value = new Float(no.value(inThisContext,line));
                if(variable.getData().equals(".") == false){
                    inThisContext.createVariable(variable.getData(), value);
                }
                else{
                    pnt = inThisContext.verificaPontos(variable.getLeft().getData(),line);
                    if(pnt == -1){
                        inThisContext.informError(ErrorMessages.ERROR_POINT_NOT_DEFINED,line,no.getLeft().getData());
                    }
                    else if(variable.getRight().getData().equals("X")){
                        Ponto oldPoint = (Ponto) JanelaPonto.getListaDePontos().getObjeto(pnt);
                        Ponto newPoint = null;
                        float pitch = inThisContext.getScene().toRadianos(oldPoint.getElevacao() + oldPoint.getBeta() + oldPoint.getGama()) - (float) Math.PI;
                        float roll = inThisContext.getScene().toRadianos(oldPoint.getRotacao());
                        ArrayList ang = inThisContext.getScene().calcularInversaPontos(-value, oldPoint.getZ(), oldPoint.getY(), pitch, roll, true);
                        if (ang == null) {
                            inThisContext.informWarning(ErrorMessages.WARNING_AXISX, line, "" + value);
                            newPoint = new Ponto(variable.getLeft().getData(), oldPoint.getX(), oldPoint.getY(), oldPoint.getZ(), oldPoint.getAlfa(), oldPoint.getBeta(), oldPoint.getGama(), oldPoint.getElevacao(), oldPoint.getRotacao());
                        } else {
                            newPoint = new Ponto(variable.getLeft().getData(), value, oldPoint.getY(), oldPoint.getZ(),inThisContext.getScene().toGraus((Float) ang.get(0)), inThisContext.getScene().toGraus((Float) ang.get(1)), inThisContext.getScene().toGraus((Float) ang.get(2)), inThisContext.getScene().toGraus((Float) ang.get(3)), inThisContext.getScene().toGraus((Float) ang.get(4)));
                        }
                        JanelaPonto.getListaDePontos().addOnoIndice(variable.getLeft().getData(), newPoint, pnt);
                    }

                    else if(variable.getRight().getData().equals("Y")){
                        Ponto oldPoint = (Ponto) JanelaPonto.getListaDePontos().getObjeto(pnt);
                        Ponto newPoint = null;
                        float pitch = inThisContext.getScene().toRadianos(oldPoint.getElevacao() + oldPoint.getBeta() + oldPoint.getGama()) - (float) Math.PI;
                        float roll = inThisContext.getScene().toRadianos(oldPoint.getRotacao());
                        ArrayList ang = inThisContext.getScene().calcularInversaPontos(-oldPoint.getX(), oldPoint.getZ(), value, pitch, roll, true);
                        if (ang == null) {
                            inThisContext.informWarning(ErrorMessages.WARNING_AXISY, line, "" + value);
                            newPoint = new Ponto(variable.getLeft().getData(), oldPoint.getX(), oldPoint.getY(), oldPoint.getZ(), oldPoint.getAlfa(), oldPoint.getBeta(), oldPoint.getGama(), oldPoint.getElevacao(), oldPoint.getRotacao());
                        } else {
                            newPoint = new Ponto(variable.getLeft().getData(), oldPoint.getX(), value, oldPoint.getZ(), inThisContext.getScene().toGraus((Float) ang.get(0)), inThisContext.getScene().toGraus((Float) ang.get(1)), inThisContext.getScene().toGraus((Float) ang.get(2)), inThisContext.getScene().toGraus((Float) ang.get(3)), inThisContext.getScene().toGraus((Float) ang.get(4)));
                        }
                        JanelaPonto.getListaDePontos().addOnoIndice(variable.getLeft().getData(), newPoint, pnt);
                    }
                    
                    else if (variable.getRight().getData().equals("Z")) {
                        Ponto oldPoint = (Ponto) JanelaPonto.getListaDePontos().getObjeto(pnt);
                        Ponto newPoint;
                        float pitch = inThisContext.getScene().toRadianos(oldPoint.getElevacao() + oldPoint.getBeta() + oldPoint.getGama()) - (float) Math.PI;
                        float roll = inThisContext.getScene().toRadianos(oldPoint.getRotacao());
                        ArrayList ang = inThisContext.getScene().calcularInversaPontos(-oldPoint.getX(), value, oldPoint.getY(), pitch, roll, true);
                        if (ang == null) {
                             inThisContext.informWarning(ErrorMessages.WARNING_AXISZ, line, "" + value);
                             newPoint = new Ponto(variable.getLeft().getData(), oldPoint.getX(), oldPoint.getY(), oldPoint.getZ(), oldPoint.getAlfa(), oldPoint.getBeta(), oldPoint.getGama(), oldPoint.getElevacao(), oldPoint.getRotacao());
                        } else {
                            newPoint = new Ponto(variable.getLeft().getData(), oldPoint.getX(), oldPoint.getZ(), value, inThisContext.getScene().toGraus((Float) ang.get(0)), inThisContext.getScene().toGraus((Float) ang.get(1)), inThisContext.getScene().toGraus((Float) ang.get(2)), inThisContext.getScene().toGraus((Float) ang.get(3)), inThisContext.getScene().toGraus((Float) ang.get(4)));
                        }
                        JanelaPonto.getListaDePontos().addOnoIndice(variable.getLeft().getData(), newPoint, pnt);

                    }
             }
            return nextInstruction;
	}

}
