/*
 * @author Gabriel Balestrin
 */
package Commands;


public interface Instruction {

	/** Sets next instruction to be executed. */
	void setNext(Instruction next);
	/**
	 * Execute this instruction and return
	 * next instruction to be executed, or
	 * null if the is no next instruction.
	 */
	Instruction execute(BlockContext inThisContext);

        /**
         * Execute a simulation to make 
         * interactions with programmation 
         */
        Instruction executeSimulation(BlockContext inThisContext);

        /*
         * Return the line
         */
        int getLine();
}
