/*
 * @author Gabriel Balestrin
 */
/*
 * Blibliography
 Title - Mathematics for Computer Graphics Applications
  Author - M.E Mortenson
 *
 * DELAMARO, Márcio Eduardo. Como construir um compilador utilizando ferramentas Java. São Paulo: Novatec, c2004. 308 p. ISBN 8575220551
 */

package Commands;


import java.util.*;
import virbot4u.CenaX3D;
import virbot4u.JanelaPrograma;


/**
 * Interprets code as a script (everything is read first
 * and stored as Instruction's, and then the instructions
 * are executed).
 */
public class ScriptingBlockContext extends AbstractBlockContext {

        Instruction firstInstr;
	Instruction lastInstr;
        Instruction currentInstr;
        
	public ScriptingBlockContext(BlockContext parent, CenaX3D scene) {
		super(parent, new HashMap<String,InstrLabel>(),
				new HashMap<String,BlockContext>(),
                                new HashMap<String,Float>(),scene);
		firstInstr = new FirstInstruction();
		lastInstr = firstInstr;
                currentInstr = firstInstr;
	}

        /** Class to initial instruction*/
	private static class FirstInstruction extends AbstractInstruction {
		public Instruction execute(BlockContext inThisContext) {
			return nextInstruction;
		}
	}

	/* This methos is implemented by everyone instructions*/
	protected void addInstr(Instruction instr) {
		lastInstr.setNext(instr);
		lastInstr = instr;
	}
        
        /* Decide which execution is the one*/
        public void run(){
            if(loop){
                executeBlockInstructionsLoop();
                loop = false;
            }else executeBlockInstructions();

        }


	public void executeBlockInstructions() {
		Instruction currentInstr = firstInstr;
		while(currentInstr != null) {
                
                      if(upDown == true){ // Have Interruptions
                            try{Thread.sleep(10);}catch(InterruptedException e){}
                            currentInstr = interruptInstr;
                            upDown = false;
                        }
			writeFeedbackLine(currentInstr.getLine());
                        currentInstr = currentInstr.execute(this);
		}
                /* If is the father of the execution, It's not a sub routine*/
                if(this.parent == null){
                    // print: end of execution 2 -> print in the konsole
                    //                         1 -> printf in the FeedBack
                    writeFeedback(1,"");
                    writeFeedback(2,"");
                    inicializeProgram();
                }
        }

         private void executeBlockInstructionsLoop() {
		
		while(true){
                     JanelaPrograma.getTxtConsole().setText("");
                     executeBlockInstructions();
                }
	}

         
        public void executeNextInstruction(){
             
            if(currentInstr == null){
               currentInstr = firstInstr;
            }
            /*else{*/
                String s[] = JanelaPrograma.getTxtProgSave().getText().split("\n", 1000);
                JanelaPrograma.getTxtProgSave().setText("");
                for(int i =1; i<=s.length;i++){

                    if(i==currentInstr.getLine()){
                        if(s[currentInstr.getLine()-1].charAt(0) == '#')
                            JanelaPrograma.getTxtProgSave().append(s[currentInstr.getLine()-1]+"\n");
                        else
                            JanelaPrograma.getTxtProgSave().append("#"+s[currentInstr.getLine()-1]+"\n");
                    }
                    else
                        if(i==s.length)
                             JanelaPrograma.getTxtProgSave().append(s[i-1].replace("#", ""));
                        else
                             JanelaPrograma.getTxtProgSave().append(s[i-1].replace("#", "")+"\n");
                }
                writeFeedbackLine(currentInstr.getLine());
                currentInstr = currentInstr.execute(this);
            /*}*/
         }

        public void inicializeProgram(){
            JanelaPrograma.getTxtProgSave().setText(JanelaPrograma.getTxtProgSave().getText().replace("#", ""));
            currentInstr = firstInstr;
        }
       

       
}
