/*
 * Created on 1/Abr/2007
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package Objetos;

import Colisao.Obb;
import Colisao.ObbTree;

/**
 * @author rejanegomes
 *	
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

public class Cilindro {

	private double raio = 0;
	private double altura = 0;
	private double anguloX = 0;
	private double anguloY = 0;
	private String nome = new String();
	private boolean emPe = true;
	private double[] posicao = new double[3];
	private float[] cor = new float[3];
	private Obb obbCil = new Obb();
	private double r;
	private ObbTree obbTree = new ObbTree();
	

	public Cilindro(double rai, double alt, String nom) {
		this.raio = rai;
		this.altura = alt;
		this.r = Math.sqrt(raio*raio + Math.pow(altura/2,2));
		this.obbCil.setEixoX(1, 0, 0);
		this.obbCil.setEixoY(0, 1, 0);
		this.obbCil.setEixoZ(0, 0, 1);
		this.obbCil.setYExtensao(alt);
		this.obbCil.setXExtensao(rai*2);
		this.obbCil.setZExtensao(rai*2);
		this.nome = nom;
		obbTree.setRoot(obbCil);
	}

	public void setCor(float[] cores) {
		cor[0] = cores[0];
		cor[1] = cores[1];
		cor[2] = cores[2];
	}

	public void setPosicao(double x, double y, double z) {
		posicao[0] = x;
		posicao[1] = y;
		posicao[2] = z;
		obbCil.setCentro(x, y, z);
	}

	public void setAnguloY(double ang) {
		anguloY = ang;
		obbCil.setAnguloY(anguloY);
	}
	
	public void setAnguloX(double ang) {
		anguloX = ang;
		obbCil.setAnguloY(ang);
	}

	public void setAnguloEixoX(double ang) {
		anguloX = ang;
		this.emPe = false;
		obbCil.setXExtensao(this.getAltura());
		obbCil.setYExtensao(this.getRaio()*2);
		obbCil.setAnguloX(anguloX);
	}

	public double getRaio() {
		return this.raio;
	}

	public double[] getPosicao() {
		return posicao;
	}
	public double getAltura() {
		return this.altura;
	}
	public boolean getStatus() {
		return emPe;
	}
	public double getAnguloX() {
		return anguloX;
	}
	public double getAnguloY() {
		return anguloY;
	}
	public String getNome() {
		return nome;
	}
	public float[] getCor() {
		return this.cor;
	}
	public double getRaioEsferaEnv() {
		return this.r;
	}
	/*
		public void setRaio(double rai)
		{
			this.raio = rai;
		
									
		}
		public void setAltura(double alt)
		{
			this.altura = alt;
		
			calculoRaioEsferaEnv();
		}
	*/
	/**
	* @return a ObbTree relativa ao objeto
	*/
	public ObbTree getObbTree() {
		return obbTree;
	}

    public Obb getObb() {
		return obbCil;
	}

}