package Robo;

public class Ponto {

    private Integer ID;
    private String nomePonto;
    private Eixo eixo;
    private Angulos angulos;
    public float radianPitch;
    public float radianRoll;
    private String nomePontoOwner;

    public Ponto(String nomePonto, Float x, Float y, Float z, Float alfa, Float beta, Float gama,
            Float elevacao, Float rotacao) {
        this.nomePonto = nomePonto;
        //this.ID=ID; //ID foi substituido por nomePonto
        this.eixo = new Eixo(x, y, z);
        this.angulos = new Angulos(alfa, beta, gama, elevacao, rotacao);
        this.nomePontoOwner = "";
    }

    public Ponto(String nomePonto, Eixo eixo, Angulos angulos) {
        super();
        this.nomePonto = nomePonto;
        this.eixo = eixo;
        this.angulos = angulos;
        this.radianPitch = 0;
        this.radianRoll = 0;
        this.nomePontoOwner = "";
    }


    public void setOwner(String nameOwner) {
        this.nomePontoOwner = nameOwner;
    }

    public String getOwner() {
        return this.nomePontoOwner;
    }

    public Float getX() {
        return eixo.getX();
    }

    public Float getY() {
        return eixo.getY();
    }

    public Float getZ() {
        return eixo.getZ();
    }

    public Float getAlfa() {
        return angulos.getAlfa();
    }

    public Float getBeta() {
        return angulos.getBeta();
    }

    public Float getElevacao() {
        return angulos.getElevacao();
    }

    public Float getGama() {
        return angulos.getGama();
    }

    public String getNomePonto() {
        return nomePonto;
    }

    public Integer getID() {
        return ID;
    }

    public Float getRotacao() {
        return angulos.getRotacao();
    }

    /**
     * Returns the angulos.
     * @return Angulos
     */
    public Angulos getAngulos() {
        return angulos;
    }

    /**
     * Returns the eixo.
     * @return Eixo
     */
    public Eixo getEixo() {
        return eixo;
    }
}
