package virbot4u;

/**
 * 
 * @author Alessandro Hoss
 */
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.*;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JRadioButton;
import javax.swing.BorderFactory;

import java.awt.*;
import java.awt.Font;
import java.awt.Rectangle;

import java.awt.event.*;
import java.awt.event.ActionListener;
import java.awt.event.KeyListener;

public class JanelaCD extends JFrame implements ActionListener, KeyListener {

    private static final long serialVersionUID = 1L;
    private JPanel jContentPane = null;
    private JLabel lblFatorCD = null;
    private JButton btBasePos = null;
    private JLabel lblBase = null;
    private JButton btBracoPos = null;
    private JButton btAntebracoPos = null;
    private JLabel lblBraco = null;
    private JLabel lblMais = null;
    private JLabel lblMenos = null;
    private JLabel lblAntebraco = null;
    private JLabel lblElevacao = null;
    private JButton btElevacaoPos = null;
    private JLabel lblRotacao = null;
    private JButton btRotacaoPos = null;
    private JButton btBaseNeg = null;
    private JButton btBracoNeg = null;
    private JButton btAntebracoNeg = null;
    private JButton btElevacaoNeg = null;
    private JButton btRotacaoNeg = null;
    private JLabel lblEixoX = null;
    private JLabel lblEixoY = null;
    private JLabel lblEixoZ = null;
    private JTextField txtEixoX = null;
    private JTextField txtEixoY = null;
    private JTextField txtEixoZ = null;
    private JTextField txtBase = null;
    private JTextField txtBraco = null;
    private JTextField txtAntebraco = null;
    private JTextField txtElevacao = null;
    private JTextField txtRotacao = null;
    public JTextField txtFator = null;
    private JPanel pnAbGarra = null;
    private JLabel lblGarra = null;
    private JLabel lblCima = null;
    private JLabel lblFrente = null;
    private JLabel lblTras = null;
    private JLabel lblLivre = null;
    private JLabel lblFixa = null;
    private JButton btAbGarra = null;
    private JButton btFecharGarra = null;
    private JButton btPosIni = null;
    private JLabel lblAbGarra = null;
    private JLabel lblLinha = null;
    private CenaX3D cena;
    private Rectangle tamanhoJanela;
    private float anguloGarra;
    public static JRadioButton rbCima = null;
    public static JRadioButton rbFrente = null;
    public static JRadioButton rbTras = null;
    public static JRadioButton rbFixa = null;
    public static JRadioButton rbLivre = null;
    public static JButton btAtualiza;

    /**
     * This is the default constructor
     */
    public JanelaCD(CenaX3D cena, Rectangle tamanhoJanela) {
        super();
        this.cena = cena;
        this.tamanhoJanela = tamanhoJanela;
        initialize();
    }

    /**
     * This method initializes this
     *
     * @return void
     */
    private void initialize() {
        this.setSize(265, 443);
        this.setLocation(tamanhoJanela.width - 365, tamanhoJanela.height - 517);
        this.setContentPane(getJContentPane());
        this.setTitle("Cinemática Direta");
        this.setIconImage(Toolkit.getDefaultToolkit().getImage("Figuras/larvao2.gif"));
        this.setAlwaysOnTop(true);
        this.setResizable(false);
        this.setVisible(true);
        this.addKeyListener(this); //eventos de teclado tratados nesta classe
        this.requestFocus();
        this.atualizaTexto();
    }

    /**
     * This method initializes jContentPane
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJContentPane() {
        if (jContentPane == null) {
            lblRotacao = new JLabel();
            lblRotacao.setBounds(new Rectangle(10, 203, 65, 14));
            lblRotacao.setFont(new Font("Tahoma", 1, 12));
            lblElevacao = new JLabel();
            lblElevacao.setBounds(new Rectangle(10, 173, 60, 14));
            lblElevacao.setFont(new Font("Tahoma", 1, 12));
            lblAntebraco = new JLabel();
            lblAntebraco.setBounds(new Rectangle(10, 143, 72, 14));
            lblAntebraco.setFont(new Font("Tahoma", 1, 12));
            lblGarra = new JLabel();
            lblGarra.setFont(new Font("Tahoma", 1, 12));
            lblGarra.setBounds(new Rectangle(10, 233, 50, 14));
            lblMais = new JLabel();
            lblMais.setFont(new Font("Tahoma", 1, 24));
            lblMais.setBounds(new Rectangle(102, 50, 20, 20));
            lblMais.setIcon(new ImageIcon("Figuras/Mais.gif"));
            lblMenos = new JLabel();
            lblMenos.setFont(new Font("Tahoma", 1, 24));
            lblMenos.setBounds(new Rectangle(150, 50, 20, 20));
            lblMenos.setIcon(new ImageIcon("Figuras/Menos.gif"));
            lblBraco = new JLabel();
            lblBraco.setBounds(new Rectangle(10, 113, 62, 14));
            lblBraco.setFont(new Font("Tahoma", 1, 12));
            lblBase = new JLabel();
            lblBase.setBounds(new Rectangle(10, 83, 36, 14));
            lblBase.setFont(new Font("Tahoma", 1, 12));
            lblFatorCD = new JLabel();
            lblFatorCD.setBounds(new Rectangle(8, 15, 125, 14));
            lblFatorCD.setFont(new Font("Tahoma", 1, 12));
            lblEixoX = new JLabel();
            lblEixoX.setForeground(Color.RED);
            lblEixoX.setBounds(new Rectangle(10, 260, 45, 25));
            lblEixoX.setText("X:");
            lblEixoX.setFont(new Font("Tahoma", 1, 12));
            lblEixoX.setForeground(Color.RED);
            lblEixoY = new JLabel();
            lblEixoY.setForeground(Color.BLUE);
            lblEixoY.setBounds(new Rectangle(90, 260, 45, 25));
            lblEixoY.setText("Y:");
            lblEixoY.setFont(new Font("Tahoma", 1, 12));
            lblEixoZ = new JLabel();
            lblEixoZ.setForeground(Color.GREEN);
            lblEixoZ.setBounds(new Rectangle(175, 260, 45, 25));
            lblEixoZ.setText("Z:");
            lblEixoZ.setFont(new Font("Tahoma", 1, 12));
            txtEixoX = new JTextField();
            txtEixoX.setFont(new Font("Tahoma", 1, 12));
            txtEixoX.setBounds(new Rectangle(25, 260, 50, 25));
            txtEixoX.setForeground(Color.RED);
            txtEixoX.setEditable(false);
            txtEixoY = new JTextField();
            txtEixoY.setFont(new Font("Tahoma", 1, 12));
            txtEixoY.setBounds(new Rectangle(110, 260, 50, 25));
            txtEixoY.setForeground(Color.BLUE);
            txtEixoY.setEditable(false);
            txtEixoZ = new JTextField();
            txtEixoZ.setFont(new Font("Tahoma", 1, 12));
            txtEixoZ.setBounds(new Rectangle(195, 260, 50, 25));
            txtEixoZ.setForeground(Color.GREEN);
            txtEixoZ.setEditable(false);
            jContentPane = new JPanel();
            jContentPane.setLayout(null);
            jContentPane.add(lblFatorCD, null);
            jContentPane.add(getBtBasePos(), null);
            jContentPane.add(lblBase, null);
            jContentPane.add(getBtAntebracoPos(), null);
            jContentPane.add(getBtBracoPos(), null);
            jContentPane.add(lblBraco, null);
            jContentPane.add(lblMais, null);
            jContentPane.add(lblMenos, null);
            jContentPane.add(lblAntebraco, null);
            jContentPane.add(lblElevacao, null);
            jContentPane.add(getTxtBase(), null);
            jContentPane.add(getBtElevacaoPos(), null);
            jContentPane.add(lblRotacao, null);
            jContentPane.add(getBtRotacaoPos(), null);
            jContentPane.add(getBtBaseNeg(), null);
            jContentPane.add(getBtAntebracoNeg(), null);
            jContentPane.add(getBtBracoNeg(), null);
            jContentPane.add(getBtElevacaoNeg(), null);
            jContentPane.add(getBtRotacaoNeg(), null);
            jContentPane.add(getTxtAntebraco(), null);
            jContentPane.add(getTxtBraco(), null);
            jContentPane.add(getTxtElevacao(), null);
            jContentPane.add(getTxtRotacao(), null);
            jContentPane.add(getTxtFator(), null);
            jContentPane.add(getPnAbGarra(), null);
            jContentPane.add(getBtAbGarra(), null);
            jContentPane.add(getBtFecharGarra(), null);
            jContentPane.add(getBtPosIni(), null);
            jContentPane.add(geBtAtualiza(), null);
            jContentPane.add(lblEixoX, null);
            jContentPane.add(lblEixoY, null);
            jContentPane.add(lblEixoZ, null);
            jContentPane.add(txtEixoX, null);
            jContentPane.add(txtEixoY, null);
            jContentPane.add(txtEixoZ, null);
            jContentPane.add(lblGarra, null);
        }
        return jContentPane;
    }

    /**
     * This method initializes btBasePos
     *
     * @return javax.swing.JButton
     */
    private JButton getBtBasePos() {
        if (btBasePos == null) {
            btBasePos = new JButton();
            btBasePos.setBounds(new Rectangle(90, 75, 45, 25));
            btBasePos.setFont(new Font("Tahoma", 1, 12));
            btBasePos.setText("1");
            btBasePos.addActionListener(this);
            btBasePos.addKeyListener(this);
        }
        return btBasePos;
    }

    /**
     * This method initializes btBracoPos
     *
     * @return javax.swing.JButton
     */
    private JButton getBtBracoPos() {
        if (btBracoPos == null) {
            btBracoPos = new JButton();
            btBracoPos.setBounds(new Rectangle(90, 105, 45, 25));
            btBracoPos.setText("2");
            btBracoPos.setFont(new Font("Tahoma", 1, 12));
            btBracoPos.addActionListener(this);
            btBracoPos.addKeyListener(this);
        }
        return btBracoPos;
    }

    /**
     * This method initializes btAntebracoPos
     *
     * @return javax.swing.JButton
     */
    private JButton getBtAntebracoPos() {
        if (btAntebracoPos == null) {
            btAntebracoPos = new JButton();
            btAntebracoPos.setBounds(new Rectangle(90, 135, 45, 25));
            btAntebracoPos.setText("3");
            btAntebracoPos.setFont(new Font("Tahoma", 1, 12));
            btAntebracoPos.addActionListener(this);
            btAntebracoPos.addKeyListener(this);
        }
        return btAntebracoPos;
    }

    /**
     * This method initializes btElevacaoPos
     *
     * @return javax.swing.JButton
     */
    private JButton getBtElevacaoPos() {
        if (btElevacaoPos == null) {
            btElevacaoPos = new JButton();
            btElevacaoPos.setBounds(new Rectangle(90, 165, 45, 25));
            btElevacaoPos.setText("4");
            btElevacaoPos.setFont(new Font("Tahoma", 1, 12));
            btElevacaoPos.addActionListener(this);
            btElevacaoPos.addKeyListener(this);
        }
        return btElevacaoPos;
    }

    /**
     * This method initializes btRotacaoPos
     *
     * @return javax.swing.JButton
     */
    private JButton getBtRotacaoPos() {
        if (btRotacaoPos == null) {
            btRotacaoPos = new JButton();
            btRotacaoPos.setBounds(new Rectangle(90, 195, 45, 25));
            btRotacaoPos.setText("5");
            btRotacaoPos.setFont(new Font("Tahoma", 1, 12));
            btRotacaoPos.addActionListener(this);
            btRotacaoPos.addKeyListener(this);
        }
        return btRotacaoPos;
    }

    /**
     * This method initializes btBaseNeg
     *
     * @return javax.swing.JButton
     */
    private JButton getBtBaseNeg() {
        if (btBaseNeg == null) {
            btBaseNeg = new JButton();
            btBaseNeg.setBounds(new Rectangle(140, 75, 45, 25));
            btBaseNeg.setText("Q");
            btBaseNeg.setFont(new Font("Tahoma", 1, 12));
            btBaseNeg.addActionListener(this);
            btBaseNeg.addKeyListener(this);
        }
        return btBaseNeg;
    }

    /**
     * This method initializes btBracoNeg
     *
     * @return javax.swing.JButton
     */
    private JButton getBtBracoNeg() {
        if (btBracoNeg == null) {
            btBracoNeg = new JButton();
            btBracoNeg.setBounds(new Rectangle(140, 105, 45, 25));
            btBracoNeg.setText("W");
            btBracoNeg.setFont(new Font("Tahoma", 1, 11));
            btBracoNeg.addActionListener(this);
            btBracoNeg.addKeyListener(this);
        }
        return btBracoNeg;
    }

    /**
     * This method initializes btAntebracoNeg
     *
     * @return javax.swing.JButton
     */
    private JButton getBtAntebracoNeg() {
        if (btAntebracoNeg == null) {
            btAntebracoNeg = new JButton();
            btAntebracoNeg.setBounds(new Rectangle(140, 135, 45, 25));
            btAntebracoNeg.setText("E");
            btAntebracoNeg.setFont(new Font("Tahoma", 1, 12));
            btAntebracoNeg.addActionListener(this);
            btAntebracoNeg.addKeyListener(this);
        }
        return btAntebracoNeg;
    }

    /**
     * This method initializes btElevacaoNeg
     *
     * @return javax.swing.JButton
     */
    private JButton getBtElevacaoNeg() {
        if (btElevacaoNeg == null) {
            btElevacaoNeg = new JButton();
            btElevacaoNeg.setBounds(new Rectangle(140, 165, 45, 25));
            btElevacaoNeg.setText("R");
            btElevacaoNeg.setFont(new Font("Tahoma", 1, 12));
            btElevacaoNeg.addActionListener(this);
            btElevacaoNeg.addKeyListener(this);
        }
        return btElevacaoNeg;
    }

    /**
     * This method initializes btRotacaoNeg
     *
     * @return javax.swing.JButton
     */
    private JButton getBtRotacaoNeg() {
        if (btRotacaoNeg == null) {
            btRotacaoNeg = new JButton();
            btRotacaoNeg.setBounds(new Rectangle(140, 195, 45, 25));
            btRotacaoNeg.setText("T");
            btRotacaoNeg.setFont(new Font("Tahoma", 1, 12));
            btRotacaoNeg.addActionListener(this);
            btRotacaoNeg.addKeyListener(this);
        }
        return btRotacaoNeg;
    }

    /**
     * This method initializes txtBase
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtBase() {
        if (txtBase == null) {
            txtBase = new JTextField();
            txtBase.setFont(new Font("Tahoma", 1, 12));
            txtBase.setBounds(new Rectangle(190, 75, 55, 25));
            txtBase.addKeyListener(this);
        }
        return txtBase;
    }

    /**
     * This method initializes txtBraco
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtAntebraco() {
        if (txtBraco == null) {
            txtBraco = new JTextField();
            txtBraco.setFont(new Font("Tahoma", 1, 12));
            txtBraco.setBounds(new Rectangle(190, 105, 55, 25));
            txtBraco.addKeyListener(this);
        }
        return txtBraco;
    }

    /**
     * This method initializes txtAntebraco
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtBraco() {
        if (txtAntebraco == null) {
            txtAntebraco = new JTextField();
            txtAntebraco.setFont(new Font("Tahoma", 1, 12));
            txtAntebraco.setBounds(new Rectangle(190, 135, 55, 25));
            txtAntebraco.addKeyListener(this);
        }
        return txtAntebraco;
    }

    /**
     * This method initializes txtElevacao
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtElevacao() {
        if (txtElevacao == null) {
            txtElevacao = new JTextField();
            txtElevacao.setFont(new Font("Tahoma", 1, 12));
            txtElevacao.setBounds(new Rectangle(190, 165, 55, 25));
            txtElevacao.addKeyListener(this);
        }
        return txtElevacao;
    }

    /**
     * This method initializes txtRotacao
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtRotacao() {
        if (txtRotacao == null) {
            txtRotacao = new JTextField();
            txtRotacao.setFont(new Font("Tahoma", 1, 12));
            txtRotacao.setBounds(new Rectangle(190, 195, 55, 25));
            txtRotacao.addKeyListener(this);
        }
        return txtRotacao;
    }

    /**
     * This method initializes txtFator
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTxtFator() {
        if (txtFator == null) {
            txtFator = new JTextField();
            txtFator.setFont(new Font("Tahoma", 1, 12));
            txtFator.setBounds(new Rectangle(120, 10, 45, 25));
            txtFator.setText("5.0");
            txtFator.addKeyListener(this);
        }
        return txtFator;
    }

    public JButton geBtAtualiza() {
        if (btAtualiza == null) {
            btAtualiza = new JButton();
            btAtualiza.setBounds(new Rectangle(75, 290, 100, 25));
            btAtualiza.setText("Update");
            btAtualiza.setFont(new Font("Tahoma", 1, 12));
            btAtualiza.addActionListener(this);
            btAtualiza.addKeyListener(this);
        }
        return btAtualiza;
    }

    /**
     * This method initializes pnAbGarra
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPnAbGarra() {
        if (pnAbGarra == null) {
            lblLinha = new JLabel();
            lblLinha.setBounds(new Rectangle(0, 10, 313, 15));
            lblLinha.setFont(new Font("Tahoma", 1, 10));
            lblLinha.setText("___________________________________________________");
            lblAbGarra = new JLabel();
            lblAbGarra.setBounds(new Rectangle(90, 5, 100, 17));
            lblAbGarra.setFont(new Font("Tahoma", 1, 12));
            lblFixa = new JLabel();
            lblFixa.setBounds(new Rectangle(25, 60, 55, 17));
            lblFixa.setFont(new Font("Tahoma", 1, 12));
            lblLivre = new JLabel();
            lblLivre.setBounds(new Rectangle(25, 35, 45, 17));
            lblLivre.setFont(new Font("Tahoma", 1, 12));
            lblTras = new JLabel();
            lblTras.setBounds(new Rectangle(100, 60, 45, 17));
            lblTras.setFont(new Font("Tahoma", 1, 12));
            lblFrente = new JLabel();
            lblFrente.setBounds(new Rectangle(100, 35, 50, 17));
            lblFrente.setFont(new Font("Tahoma", 1, 12));
            lblCima = new JLabel();
            lblCima.setBounds(new Rectangle(180, 35, 45, 16));
            lblCima.setFont(new Font("Tahoma", 1, 12));
            pnAbGarra = new JPanel();
            pnAbGarra.setLayout(null);
            pnAbGarra.setBounds(new Rectangle(10, 320, 230, 85));
            pnAbGarra.setBorder(BorderFactory.createLineBorder(new Color(0, 0, 255)));
            pnAbGarra.add(getRbCima(), null);
            pnAbGarra.add(getRbFrente(), null);
            pnAbGarra.add(getRbTras(), null);
            pnAbGarra.add(lblCima, null);
            pnAbGarra.add(lblFrente, null);
            pnAbGarra.add(lblTras, null);
            pnAbGarra.add(getRbLivre(), null);
            pnAbGarra.add(lblLivre, null);
            pnAbGarra.add(getRbFixa(), null);
            pnAbGarra.add(lblFixa, null);
            pnAbGarra.add(lblAbGarra, null);
            pnAbGarra.add(lblLinha, null);
            ButtonGroup group = new ButtonGroup();
            group.add(rbCima);
            group.add(rbFrente);
            group.add(rbTras);
            group.add(rbLivre);
            group.add(rbFixa);
        }
        return pnAbGarra;
    }

    /**
     * This method initializes rbCima
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRbCima() {
        if (rbCima == null) {
            rbCima = new JRadioButton();
            rbCima.setBounds(new Rectangle(160, 35, 21, 21));
            rbCima.addActionListener(this);
        }
        return rbCima;
    }

    /**
     * This method initializes rbFrente
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRbFrente() {
        if (rbFrente == null) {
            rbFrente = new JRadioButton();
            rbFrente.setBounds(new Rectangle(78, 35, 21, 21));
            rbFrente.addActionListener(this);
        }
        return rbFrente;
    }

    /**
     * This method initializes rbTras
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRbTras() {
        if (rbTras == null) {
            rbTras = new JRadioButton();
            rbTras.setBounds(new Rectangle(78, 60, 21, 21));
            rbTras.addActionListener(this);
        }
        return rbTras;
    }

    /**
     * This method initializes rbLivre
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRbLivre() {
        if (rbLivre == null) {
            rbLivre = new JRadioButton();
            rbLivre.setBounds(new Rectangle(5, 35, 21, 21));
            rbLivre.setSelected(true);
            rbLivre.addActionListener(this);
        }
        return rbLivre;
    }

    /**
     * This method initializes rbFixa
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRbFixa() {
        if (rbFixa == null) {
            rbFixa = new JRadioButton();
            rbFixa.setBounds(new Rectangle(5, 60, 21, 21));
            rbFixa.addActionListener(this);
        }
        return rbFixa;
    }

    /**
     * This method initializes btAbGarra
     *
     * @return javax.swing.JButton
     */

    private JButton getBtAbGarra() {
        if (btAbGarra == null) {
            ImageIcon abre = new ImageIcon("Figuras/abre.gif");
            btAbGarra = new JButton(abre);
            btAbGarra.setBounds(new Rectangle(90, 225, 45, 25));
            btAbGarra.setFont(new Font("Tahoma", 1, 12));
            btAbGarra.setActionCommand("abrirGarra");
            btAbGarra.addActionListener(this);
            btAbGarra.addKeyListener(this);
        }
        return btAbGarra;
    }

    private JButton getBtFecharGarra() {
        if (btFecharGarra == null) {
            ImageIcon fecha = new ImageIcon("Figuras/fecha.gif");
            btFecharGarra = new JButton(fecha);
            btFecharGarra.setBounds(new Rectangle(140, 225, 45, 25));
            btFecharGarra.setFont(new Font("Tahoma", 1, 12));
            btFecharGarra.setActionCommand("fecharGarra");
            btFecharGarra.addActionListener(this);
            btFecharGarra.addKeyListener(this);
        }
        return btFecharGarra;
    }
    /**
     * This method initializes btPosIni
     *
     * @return javax.swing.JButton
     */
    public JButton getBtPosIni() {
        if (btPosIni == null) {
            btPosIni = new JButton();
            btPosIni.setBounds(new Rectangle(170, 10, 80, 25));
            btPosIni.setText("Início");
            btPosIni.setFont(new Font("Tahoma", 1, 12));
            btPosIni.setActionCommand("posInicial");
            btPosIni.addActionListener(this);
            btPosIni.addKeyListener(this);
        }
        return btPosIni;
    }

    public void actionPerformed(ActionEvent e) {
        if (Float.parseFloat(txtFator.getText()) > cena.maxFator) {
            txtFator.setText("" + cena.maxFator);
        }
        if (e.getSource() instanceof JRadioButton) {
            this.requestFocus();
        }
        if (e.getSource() == btPosIni) {
            cena.setPosInicial();
            cena.NMClick();
        }
        if (btBasePos.equals(e.getSource())) {
            cena.addAlfa(this.getFatorCD());
            cena.NMClick();
        }
        if (btBracoPos.equals(e.getSource())) {
            cena.addBeta(this.getFatorCD());
            cena.NMClick();
        }
        if (btAntebracoPos.equals(e.getSource())) {
            cena.addGama(this.getFatorCD());
            cena.NMClick();
        }
        if (btElevacaoPos.equals(e.getSource())) {
            rbLivre.setSelected(true);
            cena.addElevacao(this.getFatorCD());
            cena.NMClick();
        }
        if (btRotacaoPos.equals(e.getSource())) {
            cena.addRotacao(this.getFatorCD());
            cena.NMClick();
        }
        if (btBaseNeg.equals(e.getSource())) {
            cena.addAlfa(-(this.getFatorCD()));
            cena.NMClick();
        }
        if (btBracoNeg.equals(e.getSource())) {
            cena.addBeta(-(this.getFatorCD()));
            cena.NMClick();
        }
        if (btAntebracoNeg.equals(e.getSource())) {
            cena.addGama(-(this.getFatorCD()));
            cena.NMClick();
        }
        if (btElevacaoNeg.equals(e.getSource())) {
            rbLivre.setSelected(true);
            cena.addElevacao(-(this.getFatorCD()));
            cena.NMClick();
        }
        if (btRotacaoNeg.equals(e.getSource())) {
            cena.addRotacao(-(this.getFatorCD()));
            cena.NMClick();
        }
        if (btAbGarra.equals(e.getSource())) {
            cena.abrirFecharGarra(4);
            cena.NMClick();
        }
        if (btFecharGarra.equals(e.getSource())) {
            if (cena.getPego() == false) {
                cena.abrirFecharGarra(5);
            }
            cena.NMClick();
        }
        for (int i = 0; i < 500; i++) {
            System.out.print("a");
        }
        if (rbFrente.isSelected() == true) {
            if ((90 - (cena.getBeta() + cena.getGama())) <= 130 && (90 - (cena.getBeta() + cena.getGama())) >= -130) {
                if (JanelaCI.rbFrente != null) {
                    JanelaCI.rbFrente.setSelected(true);
                }
                cena.setElevacao(90 - (cena.getBeta() + cena.getGama()));
                //cena.setTxtFeedback("Posição alcançada com sucesso!");
            } else {
                rbLivre.setSelected(true);
                cena.setTxtFeedback("Abordagem não suportada com esta configuração!");
            }
        }
        if (rbTras.isSelected() == true) {
            if ((-90 - (cena.getBeta() + cena.getGama())) <= 130 && (-90 - (cena.getBeta() + cena.getGama())) >= -130) {
                if (JanelaCI.rbTras != null) {
                    JanelaCI.rbTras.setSelected(true);
                }
                cena.setElevacao(-90 - (cena.getBeta() + cena.getGama()));
                //cena.setTxtFeedback("Posição alcançada com sucesso!");
            } else {
                rbLivre.setSelected(true);
                cena.setTxtFeedback("Abordagem não suportada com esta configuração!");
            }
        }
        if (rbFixa.isSelected() == true) {
            if ((anguloGarra - (cena.getBeta() + cena.getGama())) <= 130 && (anguloGarra - (cena.getBeta() + cena.getGama())) >= -130) {
                if (JanelaCI.rbFixa != null) {
                    JanelaCI.rbFixa.setSelected(true);
                    JanelaCI.setAng234(cena.toRadianos(cena.getElevacao() + cena.getBeta() + cena.getGama()) - (float) Math.PI);
                }
                cena.setElevacao(anguloGarra - (cena.getBeta() + cena.getGama()));
                //cena.setTxtFeedback("Posição alcançada com sucesso!");
            } else {
                rbLivre.setSelected(true);
                cena.setTxtFeedback("Abordagem não suportada com esta configuração!");
            }
        }
        if (rbCima.isSelected() == true) {
            if ((180 - (cena.getBeta() + cena.getGama())) <= 130 && (180 - (cena.getBeta() + cena.getGama())) >= -130) {
                if (JanelaCI.rbCima != null) {
                    JanelaCI.rbCima.setSelected(true);
                }
                cena.setElevacao(180 - (cena.getBeta() + cena.getGama()));
                //cena.setTxtFeedback("Posição alcançada com sucesso!");
            } else {
                rbLivre.setSelected(true);
                cena.setTxtFeedback("Abordagem não suportada com esta configuração!");
            }
        }
        try {
            Thread.sleep(20);
        } catch (InterruptedException ex) {
            Logger.getLogger(JanelaCD.class.getName()).log(Level.SEVERE, null, ex);
        }
        if (rbFixa.isSelected() == false) {
            anguloGarra = cena.getElevacao() + cena.getBeta() + cena.getGama();
        }
        if (txtBase.equals(e.getSource()) || txtBraco.equals(e.getSource()) || txtAntebraco.equals(e.getSource())
                || txtElevacao.equals(e.getSource()) || txtRotacao.equals(e.getSource())) {
        }
        cena.atualizaObbsRobo();
        this.atualizaTexto();
    }

    public float getFatorCD() {
        try {
            return Float.parseFloat(txtFator.getText());
        } catch (NumberFormatException nfe) {
            System.out.println(nfe);
            return 0;
        }
    }

    public void setIdioma(String idioma) {
        if (idioma.equals("Portugues")) {
            this.setTitle("Cinemática Direta");
            lblRotacao.setText("Rotação:");
            lblElevacao.setText("Elevação:");
            lblBraco.setText("Braço:");
            lblAntebraco.setText("Antebraço:");
            lblBase.setText("Base:");
            lblFatorCD.setText("Fator (graus):");
            lblAbGarra.setText("Abordagem");
            lblFixa.setText("Fixa");
            lblLivre.setText("Livre");
            lblTras.setText("Trás");
            lblFrente.setText("Frente");
            lblCima.setText("Cima");
            lblGarra.setText("Garra:");
            btPosIni.setText("Início");
            btAtualiza.setText("Atualizar");
        }
        if (idioma.equals("Ingles")) {
            this.setTitle("Forward kinematics");
            lblRotacao.setText("Rotation:");
            lblElevacao.setText("Elevation:");
            lblBraco.setText("Arm:");
            lblAntebraco.setText("Forearm:");
            lblBase.setText("Base:");
            lblFatorCD.setText("Factor (degrees):");
            lblAbGarra.setText("Approach");
            lblFixa.setText("Fixed");
            lblLivre.setText("Free");
            lblTras.setText("Back");
            lblFrente.setText("Front");
            lblCima.setText("Up");
            lblGarra.setText("Gripper:");
            btPosIni.setText("Home");
            btAtualiza.setText("Update");
        }
    }

    /*
     * Aqui são tratados os eventos de teclado para acionar os botões
     */
    public void keyTyped(KeyEvent evt) {
        char charPressionado = evt.getKeyChar();
        if (evt.getSource() instanceof JTextField) {
            if (charPressionado == KeyEvent.VK_ENTER) {
                this.atualizaGrafico(evt);
            } else if (charPressionado == KeyEvent.VK_ESCAPE) {
                this.atualizaTexto();
                this.requestFocus();
            } else if (charPressionado != '.' && charPressionado != '-' && (charPressionado < KeyEvent.VK_0 || charPressionado > KeyEvent.VK_9)) {
                evt.setKeyChar('\0');
            }
        } else {
            if (charPressionado == KeyEvent.VK_1) {
                this.btBasePos.doClick();
                this.btBasePos.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_2) {
                this.btBracoPos.doClick();
                this.btBracoPos.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_3) {
                this.btAntebracoPos.doClick();
                this.btAntebracoPos.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_4) {
                this.btElevacaoPos.doClick();
                this.btElevacaoPos.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_5) {
                this.btRotacaoPos.doClick();
                this.btRotacaoPos.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_6) {
                this.btAbGarra.doClick();
                this.btAbGarra.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_Q || charPressionado == Character.toLowerCase(KeyEvent.VK_Q)) {
                this.btBaseNeg.doClick();
                this.btBaseNeg.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_W || charPressionado == Character.toLowerCase(KeyEvent.VK_W)) {
                this.btBracoNeg.doClick();
                this.btBracoNeg.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_E || charPressionado == Character.toLowerCase(KeyEvent.VK_E)) {
                this.btAntebracoNeg.doClick();
                this.btAntebracoNeg.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_R || charPressionado == Character.toLowerCase(KeyEvent.VK_R)) {
                this.btElevacaoNeg.doClick();
                this.btElevacaoNeg.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_T || charPressionado == Character.toLowerCase(KeyEvent.VK_T)) {
                this.btRotacaoNeg.doClick();
                this.btRotacaoNeg.requestFocus();
                cena.NMTeclado();
            } else if (charPressionado == KeyEvent.VK_Y || charPressionado == Character.toLowerCase(KeyEvent.VK_Y)) {
                this.btFecharGarra.doClick();
                this.btFecharGarra.requestFocus();
                cena.NMTeclado();
            }
            this.atualizaTexto();
        }
    }

    public void atualizaTexto() {

        this.txtBase.setText(String.format("%.1f", cena.getAlfa()).replace(',', '.'));
        this.txtBraco.setText(String.format("%.1f", cena.getBeta()).replace(',', '.'));
        this.txtAntebraco.setText(String.format("%.1f", cena.getGama()).replace(',', '.'));
        this.txtElevacao.setText(String.format("%.1f", cena.getElevacao()).replace(',', '.'));
        this.txtRotacao.setText(String.format("%.1f", cena.getRotacao()).replace(',', '.'));

        this.txtEixoX.setText(String.format("%.1f", cena.getPontoX()).replace(',', '.'));
        this.txtEixoY.setText(String.format("%.1f", cena.getPontoY()).replace(',', '.'));
        this.txtEixoZ.setText(String.format("%.1f", cena.getPontoZ()).replace(',', '.'));
    }

    private void atualizaGrafico(KeyEvent evt) {
        try {
            if (evt.getSource() == this.txtBase) {
                float angulo = Float.valueOf(this.txtBase.getText()).floatValue();
                cena.setAlfa(angulo);
            } else if (evt.getSource() == this.txtBraco) {
                float angulo = Float.valueOf(this.txtBraco.getText()).floatValue();
                cena.setBeta(angulo);
            } else if (evt.getSource() == this.txtAntebraco) {
                float angulo = Float.valueOf(this.txtAntebraco.getText()).floatValue();
                cena.setGama(angulo);
            } else if (evt.getSource() == this.txtElevacao) {
                float angulo = Float.valueOf(this.txtElevacao.getText()).floatValue();
                cena.setElevacao(angulo);
            } else if (evt.getSource() == this.txtRotacao) {
                float angulo = Float.valueOf(this.txtRotacao.getText()).floatValue();
                cena.setRotacao(angulo);
            }
            this.requestFocus();
            if (evt.getSource() == this.txtFator) {
                if (Float.parseFloat(txtFator.getText()) > cena.maxFator) {
                    txtFator.setText("" + cena.maxFator);
                }
            }
        } catch (Exception e) {
        }
    }

    public void keyPressed(KeyEvent evt) {
    }

    public void keyReleased(KeyEvent arg0) {
    }

    public void bloqueiaTXT() {
        txtBase.setEditable(false);
        txtBraco.setEditable(false);
        txtAntebraco.setEditable(false);
        txtElevacao.setEditable(false);
        txtRotacao.setEditable(false);
    }

    public void liberaTXT() {
        txtBase.setEditable(true);
        txtBraco.setEditable(true);
        txtAntebraco.setEditable(true);
        txtElevacao.setEditable(true);
        txtRotacao.setEditable(true);
    }
}  //  @jve:decl-index=0:visual-constraint="10,10"

