/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package virbot4u;

import Preensao.*;
import Colisao.CollisionManager;
import Objetos.*;

import javax.swing.*;
import java.awt.*;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JCheckBox;
import java.awt.Font;
import javax.swing.JPanel;
import javax.swing.BorderFactory;
import java.awt.Color;
import javax.swing.JTextField;
import javax.swing.JRadioButton;
import java.awt.event.*;

import Colisao.Obb;
import Colisao.ObbTree;

public class JanelaParametros extends JFrame implements ActionListener {

    private static final long serialVersionUID = 1L;
    private JPanel jContentPane = null;
    private JPanel pnMostrar = null;
    private JLabel lblMostrar = null;
    private JCheckBox cbMostrarEixos = null;
    private JCheckBox cbMostrarPFP = null;
    private JLabel lblMostrarPFP = null;
    public JCheckBox cbMostrarColisao = null;
    private JLabel lblMostrarColisao = null;
    private JPanel pnFolga = null;
    private JLabel lblFolgaAb = null;
    private JLabel lblFolgaGeom = null;
    private JLabel lblFolga = null;
    private JLabel lblTipoTeste = null;
    public JTextField txtFolgaAb = null;
    public JTextField txtFolgaGeom = null;
    private JLabel lblLinha = null;
    private JLabel lblLinha2 = null;
    private JLabel lblLinha3 = null;
    private JPanel pnTestarPreensao = null;
    private JLabel lblContinuo = null;
    private JLabel lblDiscreto = null;
    public JRadioButton rbContinuo = null;
    public JRadioButton rbDiscreto = null;
    public static PartManager obj;
    public TrataPreensao TratPree;
    private CenaX3D cena;
    public Garra garra;
    private CollisionManager collisionManager;
    private PartManager partManager;
    private Rectangle tamanhoJanela;
    private JPanel pnElbow = null;
    private JLabel lbElbow = null;
    private JRadioButton rbElbowOver = null;
    private JRadioButton rbElbowUnder = null;
    private JPanel pnGhost = null;
    private JLabel lbGhostGripper = null;
    private JRadioButton rbGhostOn = null;
    private JRadioButton rbGhostOff = null;
    private JPanel pnGranularity = null;
    private JLabel lbGranularity = null;
    private JLabel lbGranularityPoints = null;
    private JTextField tfGranularity = null;
    private JLabel lblMostrarEixos;

    /**
     * This is the default constructor
     */
    public JanelaParametros(CenaX3D cena, Rectangle tamanhoJanela) {
        super();
        this.cena = cena;
        this.tamanhoJanela = tamanhoJanela;
        this.obj = cena.getPartManager();
        this.collisionManager = new CollisionManager();
        this.partManager = new PartManager(cena);
        this.garra = new Garra();
        initialize();
    }

    /**
     * @author Pacheco
     *
     * Método para criar labels
     */
    private JLabel createLabel(String text, int x, int y, int width, int height) {
        JLabel label = new JLabel();
        label.setText(text);
        label.setBounds(new Rectangle(x, y, width, height));
        label.setFont(new Font("Tahoma", 1, 12));
        return label;
    }

    /**
     * @author Pacheco
     *
     * Método para criar radio buttons
     */
    private JRadioButton createRadioButton(String text, int x, int y, int width, int height) {
        JRadioButton radio = new JRadioButton();
        radio.setText(text);
        radio.setBounds(new Rectangle(x, y, width, height));
        radio.setFont(new Font("Tahoma", 1, 12));
        radio.addActionListener(this);
        return radio;
    }

    /**
     * This method initializes this
     *
     * @return void
     */
    private void initialize() {
        this.setSize(357, 370);
        this.setLocation((tamanhoJanela.width / 2) - 100, (tamanhoJanela.height / 2) - 165);
        this.setContentPane(getJContentPane());
        this.setTitle("Parameters");
        this.setIconImage(Toolkit.getDefaultToolkit().getImage("Figuras/larvao2.gif"));
        this.setAlwaysOnTop(false);
        this.setVisible(true);
        this.setResizable(false);
    }

    /**
     * This method initializes jContentPane
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJContentPane() {
        if (jContentPane == null) {
            jContentPane = new JPanel();
            jContentPane.setLayout(null);
            jContentPane.add(getPnMostrar(), null);
            jContentPane.add(getPnFolga(), null);
            jContentPane.add(getPnTestarPreensao(), null);
            jContentPane.add(getPnElbow(), null);
            jContentPane.add(getPnGhost(), null);
            jContentPane.add(getPnGranularity(), null);
        }
        return jContentPane;
    }

    /**
     * @author Pacheco
     *
     * Painel Elbow
     */
    private JPanel getPnElbow() {
        if (pnElbow == null) {
            lbElbow = createLabel("Elbow", 50, 3, 50, 20);
            JLabel lbLinha = createLabel("_____________________", 0, 10, 170, 15);

            rbElbowOver = createRadioButton("Over", 10, 37, 101, 17);
            rbElbowUnder = createRadioButton("Under", 10, 62, 101, 17);
            rbElbowOver.setSelected(cena.elbowOver);
            rbElbowUnder.setSelected(!cena.elbowOver);

            ButtonGroup group = new ButtonGroup();
            group.add(rbElbowOver);
            group.add(rbElbowUnder);

            pnElbow = new JPanel();
            pnElbow.setLayout(null);
            pnElbow.setBounds(new Rectangle(180, 10, 155, 90));
            pnElbow.setBorder(BorderFactory.createLineBorder(new Color(0, 0, 255)));
            pnElbow.add(lbElbow, null);
            pnElbow.add(lbLinha, null);
            pnElbow.add(rbElbowOver, null);
            pnElbow.add(rbElbowUnder, null);
        }
        return pnElbow;
    }

    /**
     * @author Pacheco
     *
     * Painel Elbow
     */
    private JPanel getPnGhost() {
        if (pnGhost == null) {
            lblLinha = createLabel("_____________________", 0, 10, 170, 15);
            lbGhostGripper = createLabel("Ghost Gripper", 28, 3, 100, 20);
            rbGhostOn = createRadioButton("On", 10, 37, 101, 17);
            rbGhostOff = createRadioButton("Off", 10, 62, 101, 17);
            rbGhostOn.setSelected(cena.ghostGripper);
            rbGhostOff.setSelected(!cena.ghostGripper);

            ButtonGroup group = new ButtonGroup();
            group.add(rbGhostOn);
            group.add(rbGhostOff);

            pnGhost = new JPanel();
            pnGhost.setLayout(null);
            pnGhost.setBounds(new Rectangle(180, 110, 155, 90));
            pnGhost.setBorder(BorderFactory.createLineBorder(new Color(0, 0, 255)));
            pnGhost.add(lbGhostGripper, null);
            pnGhost.add(lblLinha, null);
            pnGhost.add(rbGhostOn, null);
            pnGhost.add(rbGhostOff, null);
        }
        return pnGhost;
    }

    /**
     * @author Pacheco
     *
     * Painel Granularidade
     */
    private JPanel getPnGranularity() {
        if (pnGranularity == null) {
            lbGranularity = createLabel("Granularity", 38, 3, 100, 20);
            JLabel lbLinha = createLabel("_____________________", 0, 10, 170, 15);
            lbGranularityPoints = createLabel("Points:", 10, 30, 60, 20);
            lbGranularityPoints.setFont(new Font("Tahoma", 1, 12));

            tfGranularity = new JTextField();
            tfGranularity.setBounds(new Rectangle(60, 31, 85, 20));
            tfGranularity.setText(Integer.toString(cena.granularity));
            tfGranularity.addActionListener(this);

            pnGranularity = new JPanel();
            pnGranularity.setLayout(null);
            pnGranularity.setBounds(new Rectangle(180, 210, 155, 60));
            pnGranularity.setBorder(BorderFactory.createLineBorder(new Color(0, 0, 255)));
            pnGranularity.add(lbLinha, null);
            pnGranularity.add(lbGranularity, null);
            pnGranularity.add(lbGranularityPoints, null);
            pnGranularity.add(tfGranularity, null);
        }
        return pnGranularity;
    }

    /**
     * This method initializes pnMostrar
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPnMostrar() {
        if (pnMostrar == null) {
            lblMostrar = new JLabel();
            lblMostrar.setBounds(new Rectangle(45, 5, 90, 17));
            lblMostrar.setText("Mostrar");
            lblMostrar.setFont(new Font("Tahoma", 1, 12));
            lblLinha2 = new JLabel();
            lblLinha2.setBounds(new Rectangle(0, 10, 170, 15));
            lblLinha2.setFont(new Font("Tahoma", 1, 12));
            lblLinha2.setText("_____________________");
            lblMostrarColisao = new JLabel();
            lblMostrarColisao.setBounds(new Rectangle(35, 95, 111, 17));
            lblMostrarColisao.setText("Mostrar Colisão");
            lblMostrarColisao.setFont(new Font("Tahoma", 1, 12));
            lblMostrarPFP = new JLabel();
            lblMostrarPFP.setBounds(new Rectangle(35, 65, 94, 17));
            lblMostrarPFP.setText("Mostrar PFP");
            lblMostrarPFP.setFont(new Font("Tahoma", 1, 12));
            lblMostrarEixos = new JLabel();
            lblMostrarEixos.setText("Mostrar Eixos");
            lblMostrarEixos.setBounds(new Rectangle(35, 35, 101, 17));
            lblMostrarEixos.setFont(new Font("Tahoma", 1, 12));
            pnMostrar = new JPanel();
            pnMostrar.setLayout(null);
            pnMostrar.setBounds(new Rectangle(10, 10, 155, 120));
            pnMostrar.setBorder(BorderFactory.createLineBorder(new Color(0, 0, 255)));
            pnMostrar.add(lblMostrar, null);
            pnMostrar.add(lblLinha2, null);
            pnMostrar.add(getCbMostrarEixos(), null);
            pnMostrar.add(lblMostrarEixos, null);
            pnMostrar.add(getCbMostrarPFP(), null);
            pnMostrar.add(lblMostrarPFP, null);
            pnMostrar.add(getCbMostrarColisao(), null);
            pnMostrar.add(lblMostrarColisao, null);
        }
        return pnMostrar;
    }

    /**
     * This method initializes cbMostrarEixos
     *
     * @return javax.swing.JCheckBox
     */
    public JCheckBox getCbMostrarEixos() {
        if (cbMostrarEixos == null) {
            cbMostrarEixos = new JCheckBox();
            cbMostrarEixos.setBounds(new Rectangle(10, 35, 21, 21));
            cbMostrarEixos.setSelected(true);
            cbMostrarEixos.addActionListener(this);

        }
        return cbMostrarEixos;
    }

    /**
     * This method initializes cbMostrarPFP
     *
     * @return javax.swing.JCheckBox
     */
    private JCheckBox getCbMostrarPFP() {
        if (cbMostrarPFP == null) {
            cbMostrarPFP = new JCheckBox();
            cbMostrarPFP.setBounds(new Rectangle(10, 65, 21, 21));
            cbMostrarPFP.setSelected(true);
            cbMostrarPFP.addActionListener(this);
        }
        return cbMostrarPFP;
    }

    /**
     * This method initializes cbMostrarColisao
     *
     * @return javax.swing.JCheckBox
     */
    private JCheckBox getCbMostrarColisao() {
        if (cbMostrarColisao == null) {
            cbMostrarColisao = new JCheckBox();
            cbMostrarColisao.setBounds(new Rectangle(10, 95, 21, 21));
            cbMostrarColisao.setSelected(true);
            cbMostrarColisao.addActionListener(this);
        }
        return cbMostrarColisao;
    }

    /**
     * This method initializes pnFolga
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPnFolga() {
        if (pnFolga == null) {
            lblLinha = new JLabel();
            lblLinha.setBounds(new Rectangle(0, 10, 170, 15));
            lblLinha.setFont(new Font("Tahoma", 1, 12));
            lblLinha.setText("_____________________");
            lblFolga = new JLabel();
            lblFolga.setBounds(new Rectangle(45, 5, 90, 17));
            lblFolga.setText("Folga");
            lblFolga.setFont(new Font("Tahoma", 1, 12));
            lblFolgaGeom = new JLabel();
            lblFolgaGeom.setBounds(new Rectangle(10, 65, 87, 17));
            lblFolgaGeom.setText("Geométrica:");
            lblFolgaGeom.setFont(new Font("Tahoma", 1, 12));
            lblFolgaAb = new JLabel();
            lblFolgaAb.setBounds(new Rectangle(10, 35, 89, 17));
            lblFolgaAb.setText("Abordagem:");
            lblFolgaAb.setFont(new Font("Tahoma", 1, 12));
            pnFolga = new JPanel();
            pnFolga.setLayout(null);
            pnFolga.setBounds(new Rectangle(10, 140, 155, 90));
            pnFolga.setBorder(BorderFactory.createLineBorder(new Color(0, 0, 255)));
            pnFolga.add(lblFolgaAb, null);
            pnFolga.add(lblFolgaGeom, null);
            pnFolga.add(lblFolga, null);
            pnFolga.add(getTxtFolgaAb(), null);
            pnFolga.add(getTxtFolgaGeom(), null);
            pnFolga.add(lblLinha, null);
        }
        return pnFolga;
    }

    /**
     * This method initializes txtFolgaAb
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtFolgaAb() {
        if (txtFolgaAb == null) {
            txtFolgaAb = new JTextField("50");
            txtFolgaAb.setBounds(new Rectangle(105, 30, 40, 25));
        }
        return txtFolgaAb;
    }

    /**
     * This method initializes txtFolgaGeom
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtFolgaGeom() {
        if (txtFolgaGeom == null) {
            txtFolgaGeom = new JTextField("18");
            txtFolgaGeom.setBounds(new Rectangle(105, 60, 40, 25));
        }
        return txtFolgaGeom;
    }

    /**
     * This method initializes pnTestarPreensao
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPnTestarPreensao() {
        if (pnTestarPreensao == null) {
            lblTipoTeste = new JLabel();
            lblTipoTeste.setBounds(new Rectangle(40, 5, 110, 17));
            lblTipoTeste.setText("Testar Preensão");
            lblTipoTeste.setFont(new Font("Tahoma", 1, 12));
            lblLinha3 = new JLabel();
            lblLinha3.setBounds(new Rectangle(0, 10, 170, 15));
            lblLinha3.setFont(new Font("Tahoma", 1, 12));
            lblLinha3.setText("_____________________");
            lblDiscreto = new JLabel();
            lblDiscreto.setBounds(new Rectangle(35, 65, 63, 17));
            lblDiscreto.setFont(new Font("Tahoma", 1, 12));
            lblContinuo = new JLabel();
            lblContinuo.setBounds(new Rectangle(35, 35, 80, 17));
            lblContinuo.setFont(new Font("Tahoma", 1, 12));
            pnTestarPreensao = new JPanel();
            pnTestarPreensao.setLayout(null);
            pnTestarPreensao.setBounds(new Rectangle(10, 240, 155, 90));
            pnTestarPreensao.setBorder(BorderFactory.createLineBorder(new Color(0, 0, 255)));
            pnTestarPreensao.add(lblTipoTeste, null);
            pnTestarPreensao.add(lblLinha3, null);
            pnTestarPreensao.add(lblContinuo, null);
            pnTestarPreensao.add(lblDiscreto, null);
            pnTestarPreensao.add(getRbContinuo(), null);
            pnTestarPreensao.add(getRbDiscreto(), null);
            ButtonGroup bgPreensao = new ButtonGroup();
            bgPreensao.add(rbContinuo);
            bgPreensao.add(rbDiscreto);
        }
        return pnTestarPreensao;
    }

    /**
     * This method initializes rbContinuo
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRbContinuo() {
        if (rbContinuo == null) {
            rbContinuo = new JRadioButton();
            rbContinuo.setBounds(new Rectangle(10, 35, 21, 21));
        }
        return rbContinuo;
    }

    /**
     * This method initializes rbDiscreto
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRbDiscreto() {
        if (rbDiscreto == null) {
            rbDiscreto = new JRadioButton();
            rbDiscreto.setBounds(new Rectangle(10, 65, 21, 21));
            rbDiscreto.setSelected(true);
        }
        return rbDiscreto;
    }

    public void setIdioma(String idioma) {
        if (idioma.equals("Portugues")) {
            this.setTitle("Parâmetros");
            this.lblMostrarEixos.setText("Mostrar Eixos");
            this.lblTipoTeste.setText("Testar Preensão");
            this.lblTipoTeste.setBounds(new Rectangle(20, 5, 130, 17));
            this.lblMostrar.setText("Mostrar");
            this.lblMostrarColisao.setText("Mostrar Colisão");
            this.lblMostrarPFP.setText("Mostrar PFP");
            this.lblFolga.setText("Folga");
            this.lblFolgaGeom.setText("Geométrica:");
            this.lblFolgaAb.setText("Abordagem:");
            this.lblDiscreto.setText("Discreto");
            this.lblContinuo.setText("Contínuo");
        }
        if (idioma.equals("Ingles")) {
            this.setTitle("Parameters");
            this.lblMostrarEixos.setText("Show Axes");
            this.lblTipoTeste.setText("Test Grasp");
            this.lblTipoTeste.setBounds(new Rectangle(40, 5, 90, 17));
            this.lblMostrar.setText("Show");
            this.lblMostrarColisao.setText("Show Collision");
            this.lblMostrarPFP.setText("Show PFP");
            this.lblFolga.setText("Allowance");
            this.lblFolgaGeom.setText("Geometric:");
            this.lblFolgaAb.setText("Approach:");
            this.lblDiscreto.setText("Discreet");
            this.lblContinuo.setText("Continuous");
        }
    }

    public void actionPerformed(ActionEvent e) {

        if (e.getSource() == rbElbowOver) {
            cena.elbowOver = rbElbowOver.isSelected();
            System.out.println("Elbow Over: " + cena.elbowOver);
        } else if (e.getSource() == rbElbowUnder) {
            cena.elbowOver = rbElbowOver.isSelected();
            System.out.println("Elbow Over: " + cena.elbowOver);
        } else if (e.getSource() == rbGhostOn) {
            cena.ghostGripper = rbGhostOn.isSelected();
            System.out.println("Ghost Gripper: " + cena.ghostGripper);

            System.out.println("Control Pointss: " + cena.jp.janelaPonto.lControlPoints.getItemCount());

            cena.generateGhostGripper(false, true, cena.jp.janelaPonto.isShowingControlPoints, false);
        } else if (e.getSource() == rbGhostOff) {
            cena.ghostGripper = rbGhostOn.isSelected();
            System.out.println("Ghost Gripper: " + cena.ghostGripper);

            cena.generateGhostGripper(false, false, cena.jp.janelaPonto.isShowingControlPoints, false);
        } else if (e.getSource() == tfGranularity) {
            int g;
            try {
                g = Integer.parseInt(tfGranularity.getText());
                if (g <= 0) {
                    g = 5;
                }
                cena.granularity = g;
            } catch (Exception ex) {
                ex.toString();
                g = 5;
                cena.granularity = 5;
            }
            tfGranularity.setText(Integer.toString(g));
            cena.jp.janelaPonto.updateTrajectory();

            System.out.println("Granularity: " + cena.granularity);
        } else if (e.getSource() == cbMostrarEixos) {
            if (cbMostrarEixos.isSelected()) {
                cena.setEixosVisivel(true);
            } else {
                cena.setEixosVisivel(false);
            }
        } else if (e.getSource() == cbMostrarPFP) {
            if (cbMostrarPFP.isSelected()) {
                cena.setPFPVisivel(true);
            } else {
                cena.setPFPVisivel(false);
            }
        } else if (e.getSource() == this.cbMostrarColisao) {
            cena.partManager.retiraColisao();
            cena.retiraColisao();
        }
    }
}  //  @jve:decl-index=0:visual-constraint="10,10"

