/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package virbot4u;

import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import javax.swing.*;
import java.awt.*;
import java.awt.Font;
import javax.swing.JPanel;
import java.awt.Rectangle;
import java.awt.event.ActionListener;
import javax.swing.JTextArea;
import javax.swing.JButton;
import Componentes.RList;
import Robo.*;
import java.awt.event.MouseListener;
import org.web3d.x3d.sai.X3DFieldEvent;
import org.web3d.x3d.sai.X3DFieldEventListener;

public class JanelaPonto extends JFrame implements ActionListener, X3DFieldEventListener, MouseListener {

    private static final long serialVersionUID = 1L;
    private JPanel jContentPane = null;
    public JanelaPrincipal janelaPrincipal;
    private JButton btIrAte = null;
    private JButton btRenomear = null;
    private JTextArea txtProg = null;
    private JButton btSalvarArq = null;
    private JButton btGravarPos = null;
    private JButton btExcluirPos = null;
    private JButton btAbrirArq = null;
    private JButton btViewPointsAllPoints = null;
    private JButton btViewPointsControlPoints = null;
    private JButton btAddControlPoint = null;
    private JButton btDelControlPoint = null;
    private JButton btValidadePoints = null;
    private JButton btGenerateTrajectory = null;
    private JButton btSelectPoint = null;
    private JButton btUp = null;
    private JButton btDown = null;
    /*private JButton btGenerateCode = null;*/
    private JLabel lbAllPoints = null;
    private JLabel lbControlPoints = null;
    public static RList lPontos = null;
    public static RList lControlPoints = null;
    private RList lComandos = null;
    private CenaX3D cena;
    private Rectangle tamanhoJanela;
    private JFrame janelaPonto;
    private SalvaArquivo salvaArquivo;
    public int numPonto = 0;
    private int numPontoControle = 0;
    private JButton btDeleteAllPoint = null;
    private JButton btDeleteAllControlPoint = null;
    public boolean isGeneratingTrajectory = false;
    public boolean isShowingControlPoints = false;
    public boolean isShowingAllPoints = false;
    private Font font;

    /**
     * This is the default constructor
     */
    public JanelaPonto(CenaX3D cena, Rectangle tamanhoJanela) {
        janelaPonto = new JFrame();
        this.cena = cena;
        this.tamanhoJanela = tamanhoJanela;
        this.janelaPrincipal = cena.getJanelaPrincipal();
        this.font = new Font("Tahoma", 1, 12);
        initialize();
    }

    public void PrintPonto(Ponto p) {
        System.out.println(p.getNomePonto() + ": " + p.getX() + ", " + p.getY() + ", " + p.getZ() + " # " + p.getAlfa() + ", " + p.getBeta()
                + ", " + p.getGama() + ", " + p.getElevacao() + ", " + p.getRotacao() + "(" + p.getOwner() + ")");
    }

    public void PrintList(RList list) {
        for (int i = 0; i < list.getItemCount(); i++) {
            Ponto p = (Ponto) list.getObjeto(i);
            PrintPonto(p);
        }
        System.out.println();
    }

    public static RList getListaDePontos() {
        return JanelaPonto.lPontos;
    }

    public static void setListaDePontos(Ponto ponto) {
        JanelaPonto.lPontos.addO(ponto.getNomePonto(), ponto);
    }

    private void initialize() {
        int width = 450;
        int height = 430;

        this.setSize(width, height);
        this.setContentPane(getJContentPane());
        this.setLocation((tamanhoJanela.width / 2) - (width / 2), (tamanhoJanela.height / 2) - (height / 2));
        this.setIconImage(Toolkit.getDefaultToolkit().getImage("Figuras/larvao2.gif"));
        this.setResizable(false);
        this.setAlwaysOnTop(false);
        this.setVisible(true);
    }

    private JPanel getJContentPane() {
        if (jContentPane == null) {
            jContentPane = new JPanel();
            jContentPane.setLayout(null);

            jContentPane.add(getLbAllPoints(), null);
            jContentPane.add(getLPontos(), null);
            jContentPane.add(getBtViewPointsAllPoints(), null);
            jContentPane.add(getBtIrAte(), null);
            jContentPane.add(getBtGravarPos(), null);
            jContentPane.add(getBtExcluirPos(), null);
            jContentPane.add(getBtRenomear(), null);

            jContentPane.add(getLbControlPoints(), null);
            jContentPane.add(getLControlPoints(), null);
            jContentPane.add(getBtViewPointsControlPoints(), null);
            jContentPane.add(getBtAddControlPoint(), null);
            jContentPane.add(getBtDelControlPoint(), null);
            jContentPane.add(getBtValidadePoints(), null);
            jContentPane.add(getBtGenerateTrajectory(), null);

            jContentPane.add(getBtSelectPoint(), null);
            jContentPane.add(getBtUp(), null);
            jContentPane.add(getBtDown(), null);
            /*jContentPane.add(getBtGenerateCode(), null);*/

            jContentPane.add(getBtDeleteAllPoint(), null);
            jContentPane.add(getBtDeleteAllControlPoint(), null);

            getBtAbrirArq();
            getBtSalvarArq();
        }
        return jContentPane;
    }

    // Método para criar uma label
    private JLabel createLabel(String text, int x, int y, int width, int height) {
        JLabel label = new JLabel();
        label.setText(text);
        label.setBounds(new Rectangle(x, y, width, height));
        label.setFont(new Font("Tahoma", 1, 12));
        return label;
    }

    // Cria a label All Points
    private JLabel getLbAllPoints() {
        lbAllPoints = createLabel("All Points", 55, 5, 70, 20);
        return lbAllPoints;
    }

    // Cria a label Control Points
    private JLabel getLbControlPoints() {
        lbControlPoints = createLabel("Control Points", 260, 5, 100, 20);
        return lbControlPoints;
    }

    // Método para criar uma listview
    private RList createList(int x, int y, int width, int height) {
        RList list = new RList(this);
        list.setFont(new Font("Tahoma", 1, 12));
        list.setBounds(new Rectangle(x, y, width, height));
        return list;
    }

    // Cria a lista com todos os pontos
    private RList getLPontos() {
        lPontos = createList(10, 30, 155, 120);

        // Teste Abordagem fixa
		/*lPontos.addO("P1", new Ponto("P1", new Eixo(-505.05325f, 553.4161f, 89.05451f), new Angulos(10.0f, 34.999996f, 44.999996f, 10.000008f, 0.0f)));
        lPontos.addO("P2", new Ponto("P2", new Eixo(-149.11093f, 317.26846f, 556.48926f), new Angulos(74.99999f, 69.99999f, 44.999996f, -24.999985f, 0.0f)));
        lPontos.addO("P3", new Ponto("P3", new Eixo(160.64967f, 609.63214f, 441.38153f), new Angulos(109.99999f, 25.000002f, 44.999996f, 20.0f, 0.0f)));
        lPontos.addO("P4", new Ponto("P4", new Eixo(570.8487f, 281.94025f, 49.943005f), new Angulos(174.99998f, 74.99999f, 44.999996f, -29.999983f, 0.0f)));*/

        // Teste Abordagem interpolada
		/*lPontos.addO("P1", new Ponto("P1", new Eixo(-505.05325f, 553.4161f, 89.05451f), new Angulos(10.0f, 34.999996f, 44.999996f, 10.000008f, 0.0f)));
        lPontos.addO("P2", new Ponto("P2", new Eixo(-149.11093f, 317.26846f, 556.48926f), new Angulos(74.99999f, 69.99999f, 44.999996f, -24.999985f, 0.0f)));
        lPontos.addO("P3", new Ponto("P3", new Eixo(160.64967f, 609.63214f, 441.38153f), new Angulos(109.99999f, 25.000002f, 44.999996f, 20.0f, 0.0f)));
        lPontos.addO("P4", new Ponto("P4", new Eixo(570.8487f, 281.94025f, 49.943005f), new Angulos(174.99998f, 74.99999f, 44.999996f, -29.999983f, 0.0f)));
        lPontos.addO("P5", new Ponto("P5", new Eixo(262.23f, 215.75f, 452.47f), new Angulos(120f, 65f, 60f, 0f, 0.0f)));
        lPontos.addO("P6", new Ponto("P6", new Eixo(-200.4992f, 545.30865f, 347.27484f), new Angulos(60f, 45f, 70f, -105f, 0.0f)));*/

        return lPontos;
    }

    // Cria a lista dos pontos de controle
    private RList getLControlPoints() {
        lControlPoints = createList(225, 30, 155, 120);

        // Teste Abordagem fixa
		/*lControlPoints.addO("P1", new Ponto("P1", new Eixo(-505.05325f, 553.4161f, 89.05451f), new Angulos(10.0f, 34.999996f, 44.999996f, 10.000008f, 0.0f)));
        lControlPoints.addO("P2", new Ponto("P2", new Eixo(-149.11093f, 317.26846f, 556.48926f), new Angulos(74.99999f, 69.99999f, 44.999996f, -24.999985f, 0.0f)));
        lControlPoints.addO("P3", new Ponto("P3", new Eixo(160.64967f, 609.63214f, 441.38153f), new Angulos(109.99999f, 25.000002f, 44.999996f, 20.0f, 0.0f)));
        lControlPoints.addO("P4", new Ponto("P4", new Eixo(570.8487f, 281.94025f, 49.943005f), new Angulos(174.99998f, 74.99999f, 44.999996f, -29.999983f, 0.0f)));*/

        // Teste Abordagem interpolada
		/*
        lControlPoints.addO("P1", new Ponto("P1", new Eixo(-505.05325f, 553.4161f, 89.05451f), new Angulos(10.0f, 34.999996f, 44.999996f, 10.000008f, 0.0f)));
        lControlPoints.addO("P2", new Ponto("P2", new Eixo(-149.11093f, 317.26846f, 556.48926f), new Angulos(74.99999f, 69.99999f, 44.999996f, -24.999985f, 0.0f)));
        lControlPoints.addO("P3", new Ponto("P3", new Eixo(160.64967f, 609.63214f, 441.38153f), new Angulos(109.99999f, 25.000002f, 44.999996f, 20.0f, 90f)));
        lControlPoints.addO("P4", new Ponto("P4", new Eixo(570.8487f, 281.94025f, 49.943005f), new Angulos(174.99998f, 74.99999f, 44.999996f, -29.999983f, 0.0f)));
        lControlPoints.addO("P5", new Ponto("P5", new Eixo(262.23f, 215.75f, 452.47f), new Angulos(120f, 65f, 60f, 0f, 0.0f)));
        lControlPoints.addO("P6", new Ponto("P6", new Eixo(-200.4992f, 545.30865f, 347.27484f), new Angulos(60f, 45f, 70f, -105f, -90.0f)));
        //*/
        return lControlPoints;
    }

    // Método para criar um button
    private JButton createButton(int x, int y, int width, int height) {
        JButton button = new JButton();
        button.setBounds(new Rectangle(x, y, width, height));
        button.setFont(new Font("Tahoma", 1, 12));
        button.addActionListener(this);
        return button;
    }

    // Botão de visualizar todos os pontos
    private JButton getBtViewPointsAllPoints() {
        btViewPointsAllPoints = createButton(10, 160, 155, 30);
        btViewPointsAllPoints.setText("View Points");
        return btViewPointsAllPoints;
    }

    // Botão go to
    private JButton getBtIrAte() {
        btIrAte = createButton(10, 200, 155, 30);
        return btIrAte;
    }

    // Botão para gravar a posição atual do robô
    private JButton getBtGravarPos() {
        btGravarPos = createButton(10, 240, 155, 30);
        return btGravarPos;
    }

    // Botão para excluir uma posição na lista de todos os pontos
    private JButton getBtExcluirPos() {
        btExcluirPos = createButton(10, 280, 155, 30);
        return btExcluirPos;
    }

    // Botão para renomear um ponto na lista de todos os pontos
    private JButton getBtRenomear() {
        btRenomear = createButton(10, 320, 155, 30);
        return btRenomear;
    }

    // Botão para remover todos os pontos da lista all points
    private JButton getBtDeleteAllPoint() {
        btDeleteAllPoint = createButton(10, 360, 155, 30);
        btDeleteAllPoint.setText("Remove All");
        return btDeleteAllPoint;
    }

    // Botão de visualizar os pontos de controle
    private JButton getBtViewPointsControlPoints() {
        btViewPointsControlPoints = createButton(225, 160, 155, 30);
        btViewPointsControlPoints.setText("View Points");
        return btViewPointsControlPoints;
    }

    // Botão para adicionar um ponto de controle
    private JButton getBtAddControlPoint() {
        btAddControlPoint = createButton(225, 200, 155, 30);
        btAddControlPoint.setText("Add CP");
        return btAddControlPoint;
    }

    // Botão para deletar um ponto de controle
    private JButton getBtDelControlPoint() {
        btDelControlPoint = createButton(225, 240, 155, 30);
        btDelControlPoint.setText("Remove CP");
        return btDelControlPoint;
    }

    // Botão para validar os pontos de controle
    private JButton getBtValidadePoints() {
        btValidadePoints = createButton(225, 280, 155, 30);
        btValidadePoints.setText("Validate Points");
        return btValidadePoints;
    }

    // Botão para validar os pontos de controle
    private JButton getBtGenerateTrajectory() {
        btGenerateTrajectory = createButton(225, 320, 155, 30);
        btGenerateTrajectory.setText("Generate Trajectory");
        return btGenerateTrajectory;
    }

    // Botão para remover todos os pontos de controle
    private JButton getBtDeleteAllControlPoint() {
        btDeleteAllControlPoint = createButton(225, 360, 155, 30);
        btDeleteAllControlPoint.setText("Remove All");
        return btDeleteAllControlPoint;
    }

    // Botão para mover um ponto de controle pra cima na lista
    private JButton getBtUp() {
        btUp = createButton(385, 49, 50, 24);
        btUp.setText("˄");
        btUp.setFont(new Font("Tahoma", 1, 10));
        return btUp;
    }

    // Botão para mover um ponto de controle pra baixo na lista
    private JButton getBtDown() {
        btDown = createButton(385, 79, 50, 24);
        btDown.setText("˅");
        btDown.setFont(new Font("Tahoma", 1, 10));
        return btDown;
    }

    // Botão para gerar linha de programação
	/*private JButton getBtGenerateCode()
    {
    btGenerateCode = createButton(385, 109, 50, 24);
    btGenerateCode.setText("GS");
    btGenerateCode.setFont(new Font("Tahoma", 1, 10));
    return btGenerateCode;
    }*/
    // Botão para escolher um ponto selecionado
    private JButton getBtSelectPoint() {
        btSelectPoint = createButton(170, 75, 50, 24);
        btSelectPoint.setText(">>");
        btSelectPoint.setFont(new Font("Tahoma", 1, 10));
        return btSelectPoint;
    }

    // Deprecated ###################################
    private JButton getBtAbrirArq() {
        if (btAbrirArq == null) {
            btAbrirArq = new JButton();
            btAbrirArq.setBounds(new Rectangle(155, 190, 150, 30));
            btAbrirArq.setFont(new Font("Tahoma", 1, 12));
            btAbrirArq.addActionListener(this);
        }
        return btAbrirArq;
    }

    // Deprecated ###################################
    private JButton getBtSalvarArq() {
        if (btSalvarArq == null) {
            btSalvarArq = new JButton();
            btSalvarArq.setBounds(new Rectangle(10, 190, 135, 30));
            btSalvarArq.setFont(new Font("Tahoma", 1, 12));
            btSalvarArq.addActionListener(this);
        }
        return btSalvarArq;
    }

    public void updateTrajectory() {
        if (isGeneratingTrajectory == true && lControlPoints.getItemCount() >= 4) {
            cena.generateTrajectory();
        } else if (isGeneratingTrajectory == true) {
            cena.clearTrajectory();
        }

        if (isShowingAllPoints == true) {
            cena.generateGhostGripper(true, cena.ghostGripper, isShowingAllPoints, false);
        } else {
            cena.generateGhostGripper(false, cena.ghostGripper, isShowingControlPoints, false);
        }
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == this.btExcluirPos) {
            Ponto p = (Ponto) lPontos.getObjetoSel();

            // Verificando se existe ponto correspondente na lista de pontos de controle
            boolean hasControlPoint = false;
            for (int i = 0; i < lControlPoints.getItemCount(); i++) {
                Ponto tmp = (Ponto) lControlPoints.getObjeto(i);
                if (tmp.getOwner() == p.getNomePonto()) {
                    hasControlPoint = true;
                    break;
                }
            }

            // Confirmar se o usuário deseja remover o ponto caso ele exista na lista de pontos de controle
            if (hasControlPoint == true) {
                if (JOptionPane.NO_OPTION == JOptionPane.showConfirmDialog(null, "Existem pontos de controle que utilizam esse ponto.\nSe continuar a remoção, eles serão removidos.\nDeseja continuar a remoção?", "Atenção", JOptionPane.YES_NO_OPTION)) {
                    return;
                }
            }

            // Removendo os pontos da lista de pontos de controle
            for (int i = 0; i < lControlPoints.getItemCount(); i++) {
                Ponto tmp = (Ponto) lControlPoints.getObjeto(i);
                if (p.getNomePonto() == tmp.getOwner()) {
                    lControlPoints.remove(i);
                    i = -1;
                }
            }

            lPontos.removeSel();
            lPontos.select(lPontos.getItemCount() - 1);

            updateTrajectory();
            //if (isShowingAllPoints == true) cena.generateGhostGripper(true, cena.ghostGripper, isShowingAllPoints, false);
            //else cena.generateGhostGripper(false, cena.ghostGripper, isShowingControlPoints, false);
        } else if (e.getSource() == this.btViewPointsControlPoints) {
            if (isShowingControlPoints == false) {
                this.btViewPointsControlPoints.setText("Hide Points");
            } else {
                this.btViewPointsControlPoints.setText("View Points");
            }

            isShowingControlPoints = !isShowingControlPoints;
            if (isShowingControlPoints == true) {
                isShowingAllPoints = false;
                btViewPointsAllPoints.setText("View Points");
            }

            cena.generateGhostGripper(false, cena.ghostGripper, isShowingControlPoints, false);
        } else if (e.getSource() == this.btViewPointsAllPoints) {
            if (isShowingAllPoints == false) {
                this.btViewPointsAllPoints.setText("Hide Points");
            } else {
                this.btViewPointsAllPoints.setText("View Points");
            }

            isShowingAllPoints = !isShowingAllPoints;
            if (isShowingAllPoints == true) {
                isShowingControlPoints = false;
                btViewPointsControlPoints.setText("View Points");
            }

            cena.generateGhostGripper(true, cena.ghostGripper, isShowingAllPoints, false);
        } else if (e.getSource() == this.btUp) {
            int index = lControlPoints.getSelectedIndex();
            if (index <= 0) {
                return;
            }

            Object atual = lControlPoints.getObjetoSel();
            Object ant = lControlPoints.getObjeto(index - 1);
            lControlPoints.addOnoIndice(((Ponto) atual).getNomePonto(), atual, index - 1);
            lControlPoints.addOnoIndice(((Ponto) ant).getNomePonto(), ant, index);
            lControlPoints.select(index - 1);

            updateTrajectory();

            //PrintList(lControlPoints);
        } else if (e.getSource() == this.btDown) {
            int index = lControlPoints.getSelectedIndex();
            if (index == -1 || index == lControlPoints.getItemCount() - 1) {
                return;
            }

            Object atual = lControlPoints.getObjetoSel();
            Object pos = lControlPoints.getObjeto(index + 1);
            lControlPoints.addOnoIndice(((Ponto) atual).getNomePonto(), atual, index + 1);
            lControlPoints.addOnoIndice(((Ponto) pos).getNomePonto(), pos, index);
            lControlPoints.select(index + 1);

            updateTrajectory();

            //PrintList(lControlPoints);
        } else if (e.getSource() == this.btSelectPoint || e.getSource() == this.btAddControlPoint) {
            if (lPontos.getSelectedIndex() == -1) {
                JOptionPane.showMessageDialog(null, "Selecione um ponto da lista!", "Erro", JOptionPane.ERROR_MESSAGE);
            } else {
                String nomePonto = "";
                Ponto p = (Ponto) lPontos.getObjetoSel();
                do {
                    numPontoControle++;
                    nomePonto = "P" + numPontoControle;
                } while (verificaPontosDeControle(nomePonto) != -1);
                Ponto ponto = new Ponto(nomePonto, p.getEixo(), p.getAngulos());
                ponto.setOwner(p.getNomePonto());

                //PrintPonto(ponto);
                lControlPoints.addO(ponto.getNomePonto(), ponto);
                //PrintPonto((Ponto)lControlPoints.getObjeto(lControlPoints.getItemCount()-1));
                lControlPoints.select(lControlPoints.getItemCount() - 1);
                lPontos.select(lPontos.getSelectedIndex() + 1);

                updateTrajectory();
            }
        } else if (e.getSource() == this.btDelControlPoint) {
            lControlPoints.removeSel();
            lControlPoints.select(lControlPoints.getItemCount() - 1);
            cena.generateGhostGripper(false, cena.ghostGripper, false, false);
            updateTrajectory();
        } else if (e.getSource() == this.btGenerateTrajectory) {
            if (isGeneratingTrajectory == false) {
                cena.generateTrajectory();
                btGenerateTrajectory.setText("Hide Trajectory");
            } else {
                cena.clearTrajectory();
                btGenerateTrajectory.setText("Generate Trajectory");
            }
            isGeneratingTrajectory = !isGeneratingTrajectory;
        } else if (e.getSource() == this.btValidadePoints) {
            cena.generateGhostGripper(false, cena.ghostGripper, true, true);
        } else if (e.getSource() == this.btGravarPos) {
            String nomePonto = "";
            do {
                numPonto++;
                nomePonto = "P" + numPonto;
            } while (verificaPontos(nomePonto) != -1);
            Ponto xyz = new Ponto(nomePonto,
                    this.cena.getEixo(),
                    this.cena.getAngulos());
            //adiciona a lista
            lPontos.addO(nomePonto, xyz);
            lPontos.select(lPontos.getItemCount() - 1);

            if (isShowingAllPoints) {
                updateTrajectory();
            }
        } else if (e.getSource() == this.btRenomear) {
            try {
                Ponto xyz = (Ponto) lPontos.getObjetoSel();
                if (xyz != null) {
                    String nomePonto = JOptionPane.showInputDialog("Nome do Ponto:", xyz.getNomePonto());
                    if (verificaPontos(nomePonto) != -1) {
                        JOptionPane.showMessageDialog(null, "Nome já existente!", "Erro", JOptionPane.ERROR_MESSAGE);
                    } else {
                        // Atualizando os owners na lista de pontos de controle
                        for (int i = 0; i < lControlPoints.getItemCount(); i++) {
                            Ponto tmp = (Ponto) lControlPoints.getObjeto(i);
                            if (tmp.getOwner() == xyz.getNomePonto()) {
                                tmp.setOwner(nomePonto);
                            }
                        }

                        xyz = new Ponto(nomePonto, xyz.getEixo(), xyz.getAngulos());
                        lPontos.addOnoIndice(nomePonto, xyz, lPontos.getSelectedIndex());
                    }
                }
            } catch (ArrayIndexOutOfBoundsException a) {
                JOptionPane.showMessageDialog(null, "Nenhum ponto selecionado!", "Erro", JOptionPane.ERROR_MESSAGE);
            }
        } else if (e.getSource() == this.btIrAte) {
            try {
                //captura o objeto selecionado
                Ponto xyz = (Ponto) lPontos.getObjetoSel();
                if (xyz != null) {
                    //seta os �ngulos para simulador
                    this.cena.setAngulos(xyz.getAngulos());
                }
                if (lPontos.getSelectedIndex() >= lPontos.getItemCount() - 1) {
                    lPontos.select(0);
                } else {
                    lPontos.select(lPontos.getSelectedIndex() + 1);
                }
            } catch (ArrayIndexOutOfBoundsException a) {
                JOptionPane.showMessageDialog(null, "Nenhum ponto selecionado!", "Erro", JOptionPane.ERROR_MESSAGE);
            }
        } else if (e.getSource() == this.btDeleteAllPoint) {
            if (JOptionPane.NO_OPTION == JOptionPane.showConfirmDialog(null, "Todos os pontos de controle também serão removidos. Deseja continuar a remoção?", "Atenção", JOptionPane.YES_NO_OPTION)) {
                return;
            }

            lControlPoints.removeAllObjeto();
            lPontos.removeAllObjeto();

            numPonto = 0;
            numPontoControle = 0;

            updateTrajectory();
        } else if (e.getSource() == this.btDeleteAllControlPoint) {
            lControlPoints.removeAllObjeto();
            numPontoControle = 0;
            updateTrajectory();
        } /*else if (e.getSource() == this.btGenerateCode)
        {
        if (lControlPoints.getItemCount() == 0)
        {
        JOptionPane.showMessageDialog(null, "São necessários 4 pontos no mínimo!", "Erro", JOptionPane.ERROR_MESSAGE);
        return;
        }

        String code = "GS FREE";
        for (int i = 0; i < lControlPoints.getItemCount(); i++)
        {
        code += " " + ((Ponto)lControlPoints.getObjeto(i)).getNomePonto();
        }
        code += ";";

        cena.jp.openJanelaPrograma();
        //cena.jp.janelaProg.addCommandLine(code);
        }*/ else if (e.getSource() == this.btSalvarArq) {
            if (salvaArquivo != null) {
                if (salvaArquivo.isVisible()) {
                } else {
                    salvaArquivo = new SalvaArquivo(this.cena, tamanhoJanela, "Salvar Pontos");
                    this.salvaArquivo.setIdioma(cena.getJanelaPrincipal().getIdioma());
                }
            } else {
                salvaArquivo = new SalvaArquivo(this.cena, tamanhoJanela, "Salvar Pontos");
                this.salvaArquivo.setIdioma(cena.getJanelaPrincipal().getIdioma());
            }
        } else if (e.getSource() == this.btAbrirArq) {
            if (salvaArquivo != null) {
                if (salvaArquivo.isVisible()) {
                } else {
                    salvaArquivo = new SalvaArquivo(this.cena, tamanhoJanela, "Carregar Pontos");
                    this.salvaArquivo.setIdioma(cena.getJanelaPrincipal().getIdioma());
                }
            } else {
                salvaArquivo = new SalvaArquivo(this.cena, tamanhoJanela, "Carregar Pontos");
                this.salvaArquivo.setIdioma(cena.getJanelaPrincipal().getIdioma());
            }
        }
    }

    private int verificaPontos(String nomePonto) {
        Integer numPontos = lPontos.getItemCount();
        Ponto ponto;
        for (int i = 0; i < numPontos; i++) {
            ponto = (Ponto) lPontos.getObjeto(i);
            if (nomePonto.equals(ponto.getNomePonto())) {
                return i;
            }
        }
        return -1;
    }

    private int verificaPontosDeControle(String nomePonto) {
        Integer numPontos = lControlPoints.getItemCount();
        Ponto ponto;
        for (int i = 0; i < numPontos; i++) {
            ponto = (Ponto) lControlPoints.getObjeto(i);
            if (nomePonto.equals(ponto.getNomePonto())) {
                return i;
            }
        }
        return -1;
    }

    public void readableFieldChanged(X3DFieldEvent evt) {
        //jp.getJanelaCD().atualizaTexto();
    }

    public void setIdioma(String idioma) {
        if (idioma.equals("Portugues")) {
            this.setTitle("Pontos");
            this.btIrAte.setText("Ir Até...");
            this.btRenomear.setText("Renomear");
            this.btSalvarArq.setText("Salvar Arquivo...");
            this.btAbrirArq.setText("Carregar Arquivo...");
            this.btGravarPos.setText("Gravar Posição");
            this.btExcluirPos.setText("Excluir Posição");
        }
        if (idioma.equals("Ingles")) {
            this.setTitle("Points");
            this.btIrAte.setText("Go to...");
            this.btRenomear.setText("Rename");
            this.btSalvarArq.setText("Save File...");
            this.btGravarPos.setText("Record Position");
            this.btExcluirPos.setText("Delete Position");
            this.btAbrirArq.setText("Open File...");
        }
    }

    public void mouseClicked(MouseEvent e) {
        if (e.getClickCount() == 2) {
            if (lComandos.getSelectedItem().equals("Go Position")) //Go Position
            {
                String posicao = JOptionPane.showInputDialog("Go To Position: ");
                if (posicao != null) {
                    if (verificaPontos(posicao) == -1) {
                        JOptionPane.showMessageDialog(null, "Posição Inválida!", "Erro", JOptionPane.ERROR_MESSAGE);
                    } else {
                        this.txtProg.append("GP " + posicao + ";\n");
                    }
                }
                //captura o ponto selecionado
                //Ponto xyz = (Ponto) this.lPontos.getObjetoSel();
                //se existir
                //if (xyz != null)
                //{
                //acrescenta a linha de comando correspondente

                /*
                + ((xyz.getID().intValue() < 10)
                ? ("0" + xyz.getID().toString())
                : (xyz.getID().toString()))
                + ";\n");*/
                //}
            }
            if (lComandos.getSelectedItem().equals("Wait")) {
                String tempo = JOptionPane.showInputDialog("Tempo (em milissegundos)");
                if (Integer.parseInt(tempo) < 0) {
                    JOptionPane.showMessageDialog(null, "Tempo Inválido!", "Erro", JOptionPane.ERROR_MESSAGE);
                } else {
                    this.txtProg.append("WT " + tempo + ";\n");
                }
            }
            if (lComandos.getSelectedItem().equals("Ring Bell")) {
                this.txtProg.append("RB;\n");
            }
        }
    }

    public void mousePressed(MouseEvent e) {
        //throw new UnsupportedOperationException("Not supported yet.");
    }

    public void mouseReleased(MouseEvent e) {
        //throw new UnsupportedOperationException("Not supported yet.");
    }

    public void mouseEntered(MouseEvent e) {
        //throw new UnsupportedOperationException("Not supported yet.");
    }

    public void mouseExited(MouseEvent e) {
        //throw new UnsupportedOperationException("Not supported yet.");
    }
}  //  @jve:decl-index=0:visual-constraint="10,10"

