/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package virbot4u;

import ELearning.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.event.KeyEvent;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JRadioButtonMenuItem;

/**
 * A simple example of how to use SAI to load a scene and modify a value.
 *
 * @author Alan Hudson
 * @version
 */
public class JanelaPrincipal extends JFrame implements ActionListener {

    private JanelaCD janelaCD = null;
    private JanelaCI janelaCI = null;
    private JanelaObjetos janelaObj = null;
    private JanelaPrograma janelaProg = null;
    private JanelaParametros janelaParam = null;
    public JanelaPonto janelaPonto;
    private JanelaAbout janelaAbout;
    private CenaX3D cena;
    private JMenu menuArquivo;
    private JMenu menuConfig;
    private JMenu menuAjuda;
    private JMenuItem miJanelaCD;
    private JMenuItem miJanelaCI;
    private JMenuItem miJanelaObjetos;
    private JMenuItem miJanelaParametros;
    private JMenuItem miJanelaPrograma;
    private JMenuItem miJanelaPontos;
    private JMenuItem miJanelaDescricao;
    private JMenuItem miCronometro;
    private JMenuItem miTerminarTarefa;
    private JMenuItem miIdioma;
    private JMenuItem miSair;
    private JMenu menuPontos;
    private JMenu menuCena;
    private JMenu menuTarefa;
    private JMenu menuObjetos;
    private JMenu menuProjeto;
    private JMenuItem miSalvarPontos;
    private JMenuItem miCarregarPontos;
    private JMenuItem miSalvarObjetos;
    private JMenuItem miCarregarObjetos;
    private JMenuItem miSalvarPrograma;
    private JMenuItem miCarregarPrograma;
    private JMenuItem miSalvarProjeto;
    private JMenuItem miCarregarProjeto;
    private JMenuItem miSalvarTarefa;
    private JMenuItem miCarregarTarefa;
    private JMenuItem miAbout;
    private JRadioButtonMenuItem rbPortugues;
    private JRadioButtonMenuItem rbIngles;
    private JTextField txtFeedback;
    private String idioma;
    private JFrame frame;
    private JMenuBar menuBar;
    private SalvaArquivo salvaArquivo = null;
    private Tarefa tarefa = null;

    /**
     * Constructor for the demo.
     */
    public JanelaPrincipal(CenaX3D cena, JComponent x3dPanel) {
        this.cena = cena;
        frame = new JFrame("VirBot4u");
        frame.setIconImage(Toolkit.getDefaultToolkit().getImage("Figuras/larvao2.gif"));
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.idioma = "Ingles";

        menuBar = new JMenuBar();

        menuArquivo = new JMenu("File");
        menuArquivo.setMnemonic(KeyEvent.VK_A);
        menuBar.add(menuArquivo);

        menuConfig = new JMenu("Tools");
        menuConfig.setMnemonic(KeyEvent.VK_C);
        menuBar.add(menuConfig);

        menuAjuda = new JMenu("Help");
        menuAjuda.setMnemonic(KeyEvent.VK_U);
        menuBar.add(menuAjuda);

        miJanelaCD = new JMenuItem("Forward kinematics...");
        menuConfig.add(miJanelaCD);
        miJanelaCD.addActionListener(this);
        //miJanelaCD.addActionListener(this.listener);

        miJanelaCI = new JMenuItem("Inverse kinematics...");
        menuConfig.add(miJanelaCI);
        miJanelaCI.addActionListener(this);

        miJanelaObjetos = new JMenuItem("Objects...");
        menuConfig.add(miJanelaObjetos);
        miJanelaObjetos.addActionListener(this);

        miJanelaParametros = new JMenuItem("Parameters...");
        menuConfig.add(miJanelaParametros);
        miJanelaParametros.addActionListener(this);

        miJanelaPrograma = new JMenuItem("Programming...");
        menuConfig.add(miJanelaPrograma);
        miJanelaPrograma.addActionListener(this);

        miJanelaPontos = new JMenuItem("Points...");
        menuConfig.add(miJanelaPontos);
        miJanelaPontos.addActionListener(this);

        miJanelaDescricao = new JMenuItem("Description...");
        miJanelaDescricao.setVisible(false);
        menuConfig.add(miJanelaDescricao);
        miJanelaDescricao.addActionListener(this);

        miCronometro = new JMenuItem("Timer...");
        miCronometro.setVisible(false);
        menuConfig.add(miCronometro);
        miCronometro.addActionListener(this);

        miTerminarTarefa = new JMenuItem("End Task");
        miTerminarTarefa.setVisible(false);
        menuConfig.add(miTerminarTarefa);
        miTerminarTarefa.addActionListener(this);

        miIdioma = new JMenu("Languages");
        menuConfig.add(miIdioma);
        ButtonGroup group = new ButtonGroup();
        rbPortugues = new JRadioButtonMenuItem("Portuguese");
        rbIngles = new JRadioButtonMenuItem("English");
        rbIngles.setSelected(true);
        group.add(rbPortugues);
        group.add(rbIngles);
        miIdioma.add(rbPortugues);
        miIdioma.add(rbIngles);
        rbPortugues.addActionListener(this);
        rbIngles.addActionListener(this);

        miAbout = new JMenuItem("About...");
        menuAjuda.add(miAbout);
        miAbout.addActionListener(this);

        menuPontos = new JMenu("Points");
        miSalvarPontos = new JMenuItem("Save Points");
        miCarregarPontos = new JMenuItem("Load Points");
        menuPontos.add(miSalvarPontos);
        menuPontos.add(miCarregarPontos);
        menuArquivo.add(menuPontos);
        miSalvarPontos.addActionListener(this);
        miCarregarPontos.addActionListener(this);

        menuCena = new JMenu("Objects");
        miSalvarObjetos = new JMenuItem("Save Objects");
        miCarregarObjetos = new JMenuItem("Load Objects");
        menuCena.add(miSalvarObjetos);
        menuCena.add(miCarregarObjetos);
        menuArquivo.add(menuCena);
        miSalvarObjetos.addActionListener(this);
        miCarregarObjetos.addActionListener(this);

        menuObjetos = new JMenu("Programming");
        miSalvarPrograma = new JMenuItem("Save Program");
        miCarregarPrograma = new JMenuItem("Load Program");
        menuObjetos.add(miSalvarPrograma);
        menuObjetos.add(miCarregarPrograma);
        menuArquivo.add(menuObjetos);
        miSalvarPrograma.addActionListener(this);
        miCarregarPrograma.addActionListener(this);

        menuProjeto = new JMenu("Project");
        miSalvarProjeto = new JMenuItem("Save Project");
        miCarregarProjeto = new JMenuItem("Load Project");
        menuProjeto.add(miSalvarProjeto);
        menuProjeto.add(miCarregarProjeto);
        menuArquivo.add(menuProjeto);
        miSalvarProjeto.addActionListener(this);
        miCarregarProjeto.addActionListener(this);

        menuTarefa = new JMenu("Task");
        miSalvarTarefa = new JMenuItem("Save Task");
        miCarregarTarefa = new JMenuItem("Load Task");
        menuTarefa.add(miSalvarTarefa);
        menuTarefa.add(miCarregarTarefa);
        menuArquivo.add(menuTarefa);
        miSalvarTarefa.addActionListener(this);
        miCarregarTarefa.addActionListener(this);

        miSair = new JMenuItem("Exit");
        miSair.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent event) {
                System.exit(0);
            }
        });
        menuArquivo.add(miSair);

        frame.add(x3dPanel, BorderLayout.CENTER);
        frame.add(getTxtFeedback(), BorderLayout.SOUTH);
        frame.setJMenuBar(menuBar);
        frame.setSize(1024, 768);
        frame.setExtendedState(MAXIMIZED_BOTH);
        frame.setVisible(true);
    }

    public String getIdioma() {
        return this.idioma;
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource().equals(this.miSalvarObjetos)) {
            testasalva("Salvar Objetos");
        }
        if (e.getSource().equals(this.miSalvarPontos)) {
            testasalva("Salvar Pontos");
        }
        if (e.getSource().equals(this.miSalvarPrograma)) {
            testasalva("Salvar Programas");
        }
        if (e.getSource().equals(this.miSalvarProjeto)) {
            testasalva("S Projeto");
        }
        if (e.getSource().equals(this.miCarregarObjetos)) {
            testasalva("Carregar Objetos");
        }
        if (e.getSource().equals(miCarregarPontos)) {
            testasalva("Carregar Pontos");
        }
        if (e.getSource().equals(miCarregarPrograma)) {
            testasalva("Carregar Programas");
        }
        if (e.getSource().equals(miCarregarProjeto)) {
            testasalva("C Projeto");
        }
        if (e.getSource().equals(miCarregarTarefa)) {
            if (tarefa != null) {
                if (tarefa.isVisible()) {
                } else {
                    tarefa = new Tarefa(cena, frame.getBounds());
                    tarefa.setIdioma(idioma);
                }
            } else {
                tarefa = new Tarefa(cena, frame.getBounds());
                tarefa.setIdioma(idioma);
            }
        }
        if (e.getSource().equals(miJanelaCD)) {
           /* if (janelaCI != null) {
                janelaCI.setVisible(false);
            }*/
            if (janelaCD != null) {
                JanelaCD.btAtualiza.doClick();
                janelaCD.setVisible(true);
            } else {
                janelaCD = new JanelaCD(cena, frame.getBounds());
                JanelaCD.btAtualiza.doClick();
                janelaCD.setIdioma(idioma);
            }
        }
        if (e.getSource().equals(miJanelaCI)) {
            /*if (janelaCD != null) {
                janelaCD.setVisible(false);
            }*/
            if (janelaCI != null) {
                JanelaCI.btAtualiza.doClick();
                janelaCI.setVisible(true);
            } else {
                janelaCI = new JanelaCI(cena, frame.getBounds());
                JanelaCI.btAtualiza.doClick();
                janelaCI.setIdioma(idioma);
            }
        }
        if (e.getSource().equals(miJanelaObjetos)) {
            testaJanelaObj();
        }
        if (e.getSource().equals(miJanelaParametros)) {
            if (janelaParam != null) {
                janelaParam.setVisible(true);
            } else {
                janelaParam = new JanelaParametros(cena, frame.getBounds());
                janelaParam.setIdioma(idioma);
            }
        }
        if (e.getSource().equals(miJanelaPrograma)) {
            testaJanelaProg();
        }
        if (e.getSource().equals(miJanelaPontos)) {
            testaJanelaPonto();
        }
        if (e.getSource().equals(rbPortugues)) {
            idioPortugues();
        }
        if (e.getSource().equals(rbIngles)) {
            idioIngles();
        }
        if (e.getSource().equals(miAbout)) {
            if (janelaAbout != null) {
                janelaAbout.setVisible(true);
            } else {
                janelaAbout = new JanelaAbout(cena, frame.getBounds());
                janelaAbout.setIdioma(idioma);
            }
        }
        if (e.getSource().equals(miJanelaDescricao)) {
            tarefa.jdescricao.setVisible(true);
        }
        if (e.getSource().equals(miCronometro)) {
            tarefa.cronometro.setVisible(true);
        }
        if (e.getSource().equals(miTerminarTarefa)) {
            terminaTarefa();
        }

    }

    public void idioPortugues() {
        this.idioma = "Portugues";
        this.menuArquivo.setText("Arquivo");
        this.menuPontos.setText("Pontos");
        this.menuCena.setText("Objetos");
        this.menuObjetos.setText("Programa");
        this.menuProjeto.setText("Projeto");
        this.menuTarefa.setText("Tarefa");
        this.miSalvarPontos.setText("Salvar Pontos");
        this.miCarregarPontos.setText("Carregar Pontos");
        this.miSalvarObjetos.setText("Salvar Objetos");
        this.miCarregarObjetos.setText("Carregar Objetos");
        this.miSalvarPrograma.setText("Salvar Programa");
        this.miCarregarPrograma.setText("Carregar Programa");
        this.miSalvarProjeto.setText("Salvar Projeto");
        this.miCarregarProjeto.setText("Carregar Projeto");
        this.miSalvarTarefa.setText("Salvar Tarefa");
        this.miCarregarTarefa.setText("Carregar Tarefa");
        this.menuConfig.setText("Configurações");
        this.miJanelaCD.setText("Cinemática Direta...");
        this.miJanelaCI.setText("Cinemática Inversa...");
        this.miJanelaObjetos.setText("Objetos...");
        this.miJanelaParametros.setText("Parâmetros...");
        this.miJanelaPrograma.setText("Programação...");
        this.miJanelaPontos.setText("Pontos...");
        this.miIdioma.setText("Idiomas");
        this.miSair.setText("Sair");
        this.rbPortugues.setText("Português");
        this.rbIngles.setText("Inglês");
        miJanelaDescricao.setText("Descrição...");
        miCronometro.setText("Cronometro...");
        miTerminarTarefa.setText("Terminar Tarefa");
        this.menuAjuda.setText("Ajuda");
        this.miAbout.setText("Sobre...");
        if (janelaCD != null) {
            this.janelaCD.setIdioma(this.idioma);
        }
        if (janelaCI != null) {
            this.janelaCI.setIdioma(this.idioma);
        }
        if (janelaObj != null) {
            this.janelaObj.setIdioma(this.idioma);
        }
        if (janelaParam != null) {
            this.janelaParam.setIdioma(this.idioma);
        }
        if (janelaPonto != null) {
            this.janelaPonto.setIdioma(this.idioma);
        }
        if (janelaProg != null) {
            this.janelaProg.setIdioma(this.idioma);
        }
        if (janelaAbout != null) {
            this.janelaAbout.setIdioma(this.idioma);
        }
        if (salvaArquivo != null) {
            this.salvaArquivo.setIdioma(this.idioma);
        }
        if (tarefa != null) {
            if (tarefa.cronometro != null) {
                tarefa.cronometro.setIdioma(this.idioma);
            }
            this.tarefa.setIdioma(this.idioma);
            if (tarefa.jdescricao != null) {
                tarefa.jdescricao.setIdioma(this.idioma);
            }
        }
    }

    public void idioIngles() {
        this.idioma = "Ingles";
        this.menuArquivo.setText("File");
        this.menuPontos.setText("Points");
        this.menuCena.setText("Objects");
        this.menuObjetos.setText("Program");
        this.menuProjeto.setText("Project");
        this.menuTarefa.setText("Task");
        this.miSalvarPontos.setText("Save Points");
        this.miCarregarPontos.setText("Load Points");
        this.miSalvarObjetos.setText("Save Objects");
        this.miCarregarObjetos.setText("Load Objects");
        this.miSalvarPrograma.setText("Save Program");
        this.miCarregarPrograma.setText("Load Program");
        this.miSalvarProjeto.setText("Save Project");
        this.miCarregarProjeto.setText("Load Project");
        this.miSalvarTarefa.setText("Save Task");
        this.miCarregarTarefa.setText("Load Task");
        this.menuConfig.setText("Tools");
        this.miJanelaCD.setText("Forward kinematics ...");
        this.miJanelaCI.setText("Inverse kinematics...");
        this.miJanelaObjetos.setText("Objects ...");
        this.miJanelaParametros.setText("Parameters...");
        this.miJanelaPrograma.setText("Programming...");
        this.miJanelaPontos.setText("Points...");
        this.miIdioma.setText("Languages...");
        this.miSair.setText("Exit");
        this.rbPortugues.setText("Portuguese");
        this.rbIngles.setText("English");
        miJanelaDescricao.setText("Description...");
        miCronometro.setText("Timer...");
        miTerminarTarefa.setText("End Task");
        this.menuAjuda.setText("Help");
        this.miAbout.setText("About...");
        if (janelaCD != null) {
            this.janelaCD.setIdioma(this.idioma);
        }
        if (janelaCI != null) {
            this.janelaCI.setIdioma(this.idioma);
        }
        if (janelaObj != null) {
            this.janelaObj.setIdioma(this.idioma);
        }
        if (janelaParam != null) {
            this.janelaParam.setIdioma(this.idioma);
        }
        if (janelaPonto != null) {
            this.janelaPonto.setIdioma(this.idioma);
        }
        if (janelaProg != null) {
            this.janelaProg.setIdioma(this.idioma);
        }
        if (janelaAbout != null) {
            this.janelaAbout.setIdioma(this.idioma);
        }
        if (salvaArquivo != null) {
            this.salvaArquivo.setIdioma(this.idioma);
        }
        if (tarefa != null) {
            if (tarefa.cronometro != null) {
                tarefa.cronometro.setIdioma(this.idioma);
            }
            this.tarefa.setIdioma(this.idioma);
            if (tarefa.jdescricao != null) {
                tarefa.jdescricao.setIdioma(this.idioma);
            }
        }
    }

    public Rectangle tamanhoJanela() {
        return frame.getBounds();
    }

    public JanelaCD getJanelaCD() {
        return janelaCD;
    }

    public JanelaCI getJanelaCI() {
        return janelaCI;
    }

    public JanelaObjetos getJanelaObj() {
        return janelaObj;
    }

    public JanelaParametros getJanelaParam() {
        if (janelaParam == null) {
            janelaParam = new JanelaParametros(cena, frame.getBounds());
            janelaParam.setIdioma(idioma);
            janelaParam.setVisible(false);
        }
        return janelaParam;
    }

    public JanelaPrograma getJanelaProg() {
        return janelaProg;
    }

    public SalvaArquivo getsalvaArquivo() {
        return salvaArquivo;
    }

    public JanelaPonto getJanelaPonto() {
        return janelaPonto;
    }

    public void testasalva(String tipo) {
        if (salvaArquivo != null) {
            if (salvaArquivo.isVisible()) {
            } else {
                salvaArquivo = new SalvaArquivo(cena, frame.getBounds(), tipo);
                salvaArquivo.setIdioma(idioma);
            }
        } else {
            salvaArquivo = new SalvaArquivo(cena, frame.getBounds(), tipo);
            salvaArquivo.setIdioma(idioma);
        }
    }

    public void testasalva2(String tipo) {
        if (salvaArquivo == null) {
            salvaArquivo = new SalvaArquivo(cena, frame.getBounds(), tipo);
            salvaArquivo.setIdioma(idioma);
            salvaArquivo.setVisible(false);
        }
    }

    public void testaJanelaProg() {
        if (janelaProg != null) {
            janelaProg.setVisible(true);
        } else {
            janelaProg = new JanelaPrograma(this.cena, frame.getBounds());
            this.janelaProg.setIdioma(this.idioma);
        }
    }

    public void testaJanelaCD() {
        if (janelaCD != null); else {
            janelaCD = new JanelaCD(this.cena, frame.getBounds());
            this.janelaCD.setIdioma(this.idioma);
            janelaCD.setVisible(false);
        }
    }

    public void testaJanelaCI() {
        if (janelaCI != null); else {
            janelaCI = new JanelaCI(this.cena, frame.getBounds());
            this.janelaCI.setIdioma(this.idioma);
            janelaCI.setVisible(false);
        }
    }

    public void testaJanelaPonto() {
        if (janelaPonto != null) {
            janelaPonto.setVisible(true);
        } else {
            janelaPonto = new JanelaPonto(this.cena, frame.getBounds());
            this.janelaPonto.setIdioma(this.idioma);
        }
    }

    public void testaJanelaObj() {
        if (janelaObj != null) {
            janelaObj.setVisible(true);
        } else {
            janelaObj = new JanelaObjetos(this.cena, frame.getBounds());
            this.janelaObj.setIdioma(this.idioma);
        }
    }

    public void atualizarTarefa() {
        miJanelaDescricao.setVisible(true);
        miCronometro.setVisible(true);
        miTerminarTarefa.setVisible(true);
        cena.NManipulacoesClick = 0;
        cena.NManipulacoesTeclado = 0;
        cena.NPreencaoO = 0;
        cena.NPreencaoOF = 0;
        cena.NPreencaoOM = 0;
        cena.maxFator = 10;
        testaJanelaCD();
        janelaCD.bloqueiaTXT();
        testaJanelaCI();
        janelaCI.bloqueiaTXT();
        cena.setPosInicial();
        cena.setSensoresAtivos(false);
        this.miCarregarTarefa.setVisible(false);
        cena.FolgaAb = "45";
        cena.FolgaGeom = "18";
        if (janelaParam != null) {
            janelaParam.cbMostrarColisao.setSelected(true);
        }
        if (tarefa.bloqueio[0] == 1) {
            this.miJanelaCD.setVisible(false);
            this.janelaCD.setVisible(false);
        }
        if (tarefa.bloqueio[1] == 1) {
            this.miJanelaCI.setVisible(false);
            this.janelaCI.setVisible(false);
        }
        if (tarefa.bloqueio[2] == 1) {
            this.miJanelaObjetos.setVisible(false);
            if (janelaObj != null) {
                this.janelaObj.setVisible(false);
            }
        }
        if (tarefa.bloqueio[3] == 1) {
            this.miJanelaPrograma.setVisible(false);
            if (janelaProg != null) {
                this.janelaProg.setVisible(false);
            }
        }
        if (tarefa.bloqueio[4] == 1) {
            this.miJanelaParametros.setVisible(false);
            if (janelaParam != null) {
                this.janelaParam.setVisible(false);
            }
        }
        if (tarefa.bloqueio[5] == 1) {
            this.miJanelaPontos.setVisible(false);
            if (janelaPonto != null) {
                this.janelaPonto.setVisible(false);
            }
        }
        if (tarefa.bloqueio[6] == 1) {
            this.miCarregarPontos.setVisible(false);
        }
        if (tarefa.bloqueio[7] == 1) {
            this.miCarregarPrograma.setVisible(false);
        }
        if (tarefa.bloqueio[8] == 1) {
            this.miCarregarObjetos.setVisible(false);
        }
        if (tarefa.bloqueio[9] == 1) {
            this.miCarregarProjeto.setVisible(false);
        }
        if (tarefa.bloqueio[10] == 1) {
            if (janelaParam != null) {
                this.janelaParam.cbMostrarColisao.setSelected(false);
            }
        }
        if (tarefa.bloqueio[11] == 1) {
            if (janelaParam != null) {
                cena.usoPreensao = 0;
            }
        }
        if (tarefa.bloqueio[12] == 1) {
            this.miSalvarPontos.setVisible(false);
        }
        if (tarefa.bloqueio[13] == 1) {
            this.miSalvarPrograma.setVisible(false);
        }
        if (tarefa.bloqueio[14] == 1) {
            this.miSalvarObjetos.setVisible(false);
        }
        if (tarefa.bloqueio[15] == 1) {
            this.miSalvarProjeto.setVisible(false);
        }
        this.miJanelaObjetos.setVisible(false);
        this.janelaObj.setVisible(false);
    }

    public void terminaTarefa() {
        tarefa.jdescricao.setVisible(false);
        tarefa.cronometro.setVisible(false);
        miJanelaDescricao.setVisible(false);
        miCronometro.setVisible(false);
        miTerminarTarefa.setVisible(false);
        this.miJanelaCD.setVisible(true);
        this.miJanelaCI.setVisible(true);
        this.miJanelaObjetos.setVisible(true);
        this.miJanelaPrograma.setVisible(true);
        this.miJanelaParametros.setVisible(true);
        this.miJanelaPontos.setVisible(true);
        this.miCarregarPontos.setVisible(true);
        this.miCarregarPrograma.setVisible(true);
        this.miCarregarObjetos.setVisible(true);
        this.miCarregarProjeto.setVisible(true);
        this.miCarregarTarefa.setVisible(true);
        this.miSalvarPontos.setVisible(true);
        this.miSalvarPrograma.setVisible(true);
        this.miSalvarObjetos.setVisible(true);
        this.miSalvarProjeto.setVisible(true);
        cena.setSensoresAtivos(true);
        janelaCD.liberaTXT();
        janelaCI.liberaTXT();
        if (janelaParam != null) {
            this.janelaParam.cbMostrarColisao.setSelected(true);
        }
        if (janelaParam != null) {
            cena.usoPreensao = 1;
        }
        cena.maxFator = 180;
        tarefa.metric.arquivoFinal(tarefa.metricas, cena, tarefa.nome, tarefa.descricao, tarefa.posicao, tarefa.orientacao, tarefa.deitado, tarefa.folgaPosicao, tarefa.folgaOrientacao, tarefa.nomeUsuario);
    }

    private JTextField getTxtFeedback() {
        txtFeedback = new JTextField();
        txtFeedback.setSize(1000, 30);
        txtFeedback.setEditable(false);
        return txtFeedback;
    }

    public void setTxtFeedback(String feedback) {
        this.txtFeedback.setText(feedback);
        frame.setVisible(true);
    }
}
