/* 
 * This class displayed a window for programming
 * @author Gabriel Balestrin
 */
package virbot4u;

import javax.swing.*;     // Windows' import (AbstractListModel, BorderFactory, GroupLayout, ImageIcon, JButton, JFrame, JLabel, JList, JOptionPane, JPanel, JScrollPane, JTextArea)
import java.awt.*;        // Layout's import (Rectangle,Toolkit)
import java.awt.event.*;  // Events' import (ActionEvent,ActionListener,MouseEvent,MouseListener)
import Componentes.RList;
import Robo.*;
import Commands.*;           // Import compiler's block
import Compiler.*;          // Import syntatic analizator

public class JanelaPrograma extends JFrame implements ActionListener, MouseListener {

    // Variables declaration
    private JButton newFile;
    private JButton openFile;
    private JButton saveFile;
    private JButton run;
    private JButton stop;
    private JButton stepNext;
    private JButton digitalWindow;
    private JButton loop;
    private JButton reset;
    private JButton home;
    private JLabel cmdTitle;
    private JList cmdList;
    private JPanel panelBottons;
    private JPanel panelProg;
    private JPanel panelCmd;
    private JPanel panelConsole;
    private JScrollPane jScrollPane1;
    private JScrollPane jScrollPane2;
    private JScrollPane jScrollPane3;
    private static JTextArea txtProg;
    private static JTextArea txtConsole;
    private RList lPontos;
    private CenaX3D cena;
    private Rectangle tamanhoJanela;
    private JanelaPonto janelaPonto;
    private SalvaArquivo salvaArquivo;
    private static String idioma;
    private BlockContext blockContext;
    private JanelaDigital jDigital;
    String[] strings_en = {
        "   AXIS CONTROL",
        "OG OpenGripper",
        "CG CloseGripper",
        "GP GoToPosition#_",
        "GL GoLinearToPosition#_",
        "GC GoCircularToPosition#_",
        "GS GoSmoothToPosition#_",
        "JA JAW...",
        "IL IfLimitSwitch#_...",
        "RP RecordPosition#_...",
        "SA SetAxis#_ ToZero...",
        "PH SetHomePosition",
        "SVS SetVariableToSensor...",
        "   PROGRAM FLOW",
        "WT Wait...",
        "JU JumpTo...",
        "RE Remark...",
        "RB RingBell",
        "RT ResetTimer",
        "SVC SetVariable...",
        "SVT SetVariableToTimer...",
        "IF IfJump...",
        "SS SetSubroutine...",
        "CS CallSubroutine...",
        "RS ReturnSubroutine",
        "LA Label...",
        "PS PrintToScreen&Log...",
        "   INPUTS & OUTPUTS",
        "II IfInput#_OnJump...",
        "OI OnInputInt#_OnJump...",
        "EI EnableInterrupt#_...",
        "DI DisableInterrupt#_...",
        "ON TurnOnOutput#_...",
        "OF TurnOffOutput#_..."};
    String[] strings_pt = {
        "   CONTROLE DOS EIXOS",
        "OG AbrirGarra",
        "CG FecharGarra",
        "GP IrParaPosicao#_",
        "GL IrLinearParaPosicao#_",
        "GC IrCircularParaPosicao#_",
        "GS IrSuaveParaPosicao#_",
        "JA Abertura...",
        "IL SeLimiteMudar#_...",
        "RP GravarPosicao#_...",
        "SA DefinirEixos#_ EmZero...",
        "PH DefinirPosicaoInicial",
        "SVS DefinirVarivelAoSensor...",
        "   FLUXO DE PROGRAMA",
        "WT Esperar...",
        "JU PularPara...",
        "RE Comentario...",
        "RB Campainha",
        "RT ReiniciarTempo",
        "SVC DefinirVariavel...",
        "SVT DefinirVariavelAoTempo...",
        "IF SePular...",
        "SS DefinirSubrotina...",
        "CS ChamarSubrotina...",
        "RS RetornarSubrotina",
        "LA Rotulo...",
        "PS ImprimirNaTela&Log...",
        "   ENTRADAS & SAIDAS",
        "II SeEntrada#_AtivadaPular...",
        "OI OnInputInt#_OnJump...",
        "EI AbilitarInterrupcao#_...",
        "DI DesabilitarInterrupcao#_...",
        "ON AcionarSaida#_...",
        "OF DesligarSaida#_...",};
    private static Ponto homePosition;
    // End of variables declaration

    /**
     * This is the default constructor
     */
    public JanelaPrograma(CenaX3D cena, Rectangle tamanhoJanela) {
        super();
        this.cena = cena;
        this.tamanhoJanela = tamanhoJanela;
        idioma = "Portugues";
        float h = 0;
        this.homePosition = new Ponto("Home", h, h, h, h, h, h, h, h);
        jDigital = new JanelaDigital();
        initComponents();
    }

    /**
     * Initializes the components of the programming window.
     */
    private void initComponents() {

        this.setTitle("Programação");
        this.setLocation(0, tamanhoJanela.height - 465);

        GroupLayout layout = new GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(getJPanelBotton(), GroupLayout.DEFAULT_SIZE, 395, Short.MAX_VALUE).addGroup(GroupLayout.Alignment.TRAILING, layout.createSequentialGroup().addGroup(layout.createParallelGroup(GroupLayout.Alignment.TRAILING).addComponent(getJPanelConsole(), GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE).addGroup(layout.createSequentialGroup().addComponent(getJPanelProg(), GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE).addGap(0, 0, 0).addComponent(getJPanelCmd(), GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))).addGap(0, 0, 0)));
        layout.setVerticalGroup(
                layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(layout.createSequentialGroup().addComponent(getJPanelBotton(), GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE).addGap(5, 5, 5).addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(getJPanelCmd(), GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE).addComponent(getJPanelProg(), GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)).addGap(5, 5, 5).addComponent(getJPanelConsole(), GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE).addContainerGap()));
        pack();
        this.setIconImage(Toolkit.getDefaultToolkit().getImage("Figuras/larvao2.gif"));
        this.setAlwaysOnTop(false);
        this.setVisible(true);

    }

    /** Creates and returns the Panel button*/
    private JPanel getJPanelBotton() {

        if (panelBottons == null) {
            panelBottons = new JPanel();
            panelBottons.setBorder(BorderFactory.createEtchedBorder());

            GroupLayout jPanel1Layout = new GroupLayout(panelBottons);
            panelBottons.setLayout(jPanel1Layout);
            jPanel1Layout.setHorizontalGroup(
                    jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(jPanel1Layout.createSequentialGroup().addComponent(getJButtonNewF(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addGap(0, 0, 0).addComponent(getJButtonOpenF(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addGap(0, 0, 0).addComponent(getJButtonSave(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addGap(0, 0, 0).addComponent(getJButtonPlay(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addGap(0, 0, 0).addComponent(getJButtonLoop(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addGap(0, 0, 0).addComponent(getJButtonStop(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addGap(0, 0, 0).addComponent(getJButtonStep(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addGap(0, 0, 0).addComponent(getJButtonReset(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addGap(0, 0, 0).addComponent(getJButtonHome(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addGap(0, 0, 0).addComponent(getJButtondigitalWindow(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addGap(73, 73, 73)));
            jPanel1Layout.setVerticalGroup(
                    jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(getJButtonNewF(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addComponent(getJButtonOpenF(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addComponent(getJButtonSave(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addComponent(getJButtonPlay(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addComponent(getJButtonLoop(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addComponent(getJButtonStop(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addComponent(getJButtonStep(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE)).addComponent(getJButtonReset(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addComponent(getJButtonHome(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE).addComponent(getJButtondigitalWindow(), GroupLayout.PREFERRED_SIZE, 35, GroupLayout.PREFERRED_SIZE));
        }
        return panelBottons;
    }

    /** Creates and returns the Panel Programmating*/
    private JPanel getJPanelProg() {
        if (panelProg == null) {
            panelProg = new JPanel();

            GroupLayout jPanel2Layout = new GroupLayout(panelProg);
            panelProg.setLayout(jPanel2Layout);
            jPanel2Layout.setHorizontalGroup(
                    jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(jPanel2Layout.createSequentialGroup().addComponent(getJScrollPaneProg(), GroupLayout.DEFAULT_SIZE, 205, Short.MAX_VALUE).addContainerGap()));
            jPanel2Layout.setVerticalGroup(
                    jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(getJScrollPaneProg(), GroupLayout.DEFAULT_SIZE, 239, Short.MAX_VALUE));
        }
        return panelProg;
    }

    /** Creates and returns the Commmand Panel*/
    private JPanel getJPanelCmd() {
        if (panelCmd == null) {

            panelCmd = new JPanel();

            GroupLayout jPanel3Layout = new GroupLayout(panelCmd);
            panelCmd.setLayout(jPanel3Layout);
            jPanel3Layout.setHorizontalGroup(
                    jPanel3Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(getJLabelCmd(), GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE).addComponent(getJScrollPaneCmd(), GroupLayout.DEFAULT_SIZE, 180, Short.MAX_VALUE));
            jPanel3Layout.setVerticalGroup(
                    jPanel3Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(jPanel3Layout.createSequentialGroup().addComponent(getJLabelCmd(), GroupLayout.PREFERRED_SIZE, 22, GroupLayout.PREFERRED_SIZE).addGap(0, 0, 0).addComponent(getJScrollPaneCmd(), GroupLayout.DEFAULT_SIZE, 217, Short.MAX_VALUE)));
        }
        return panelCmd;
    }

    /** Creates and returns the Console Panel*/
    private JPanel getJPanelConsole() {
        if (panelConsole == null) {
            panelConsole = new JPanel();

            GroupLayout jPanel4Layout = new GroupLayout(panelConsole);
            panelConsole.setLayout(jPanel4Layout);
            jPanel4Layout.setHorizontalGroup(
                    jPanel4Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(getJScrollPaneConsole(), GroupLayout.DEFAULT_SIZE, 395, Short.MAX_VALUE));
            jPanel4Layout.setVerticalGroup(
                    jPanel4Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(getJScrollPaneConsole(), GroupLayout.PREFERRED_SIZE, 61, GroupLayout.PREFERRED_SIZE));
        }
        return panelConsole;
    }

    /** Creates and returns the button New File*/
    private JButton getJButtonNewF() {
        if (newFile == null) {
            newFile = new JButton();
            newFile.setIcon(new ImageIcon("Figuras/new.gif")); // NOI18N
            newFile.addMouseListener(this);
            newFile.addActionListener(this);

        }
        return newFile;
    }

    /** Creates and returns the button Open File*/
    private JButton getJButtonOpenF() {
        if (openFile == null) {
            openFile = new JButton();

            openFile.setIcon(new ImageIcon("Figuras/open.gif")); // NOI18N
            openFile.addMouseListener(this);
            openFile.addActionListener(this);
        }
        return openFile;
    }

    /** Creates and returns the button Save*/
    private JButton getJButtonSave() {
        if (saveFile == null) {
            saveFile = new JButton();

            saveFile.setIcon(new ImageIcon("Figuras/save.gif")); // NOI18N
            saveFile.addMouseListener(this);
            saveFile.addActionListener(this);
        }
        return saveFile;
    }

    /** Creates and returns the button Play*/
    private JButton getJButtonPlay() {
        if (run == null) {
            run = new JButton();
            run.setIcon(new ImageIcon("Figuras/play.gif")); // NOI18N
            run.addMouseListener(this);
            run.addActionListener(this);
        }
        return run;
    }

    /** Creates and returns the button Loop*/
    private JButton getJButtonLoop() {
        if (loop == null) {
            loop = new JButton();
            loop.setIcon(new ImageIcon("Figuras/loop.gif")); // NOI18N
            loop.addMouseListener(this);
            loop.addActionListener(this);
        }
        return loop;
    }

    /** Creates and returns the button Stop*/
    private JButton getJButtonStop() {
        if (stop == null) {
            stop = new JButton();
            stop.setIcon(new ImageIcon("Figuras/stop.gif")); // NOI18N
            stop.addMouseListener(this);
            stop.addActionListener(this);
        }
        return stop;
    }

    /** Creates and returns the button Step*/
    private JButton getJButtonStep() {
        if (stepNext == null) {

            stepNext = new JButton();
            stepNext.setIcon(new ImageIcon("Figuras/step.gif")); // NOI18N
            stepNext.addMouseListener(this);
            stepNext.addActionListener(this);
        }
        return stepNext;
    }

    /** Creates and returns the button Back*/
    private JButton getJButtondigitalWindow() {
        if (digitalWindow == null) {
            digitalWindow = new JButton();

            digitalWindow.setIcon(new ImageIcon("Figuras/io.gif")); // NOI18N
            digitalWindow.addMouseListener(this);
            digitalWindow.addActionListener(this);
        }
        return digitalWindow;
    }

    /** Creates and returns the button Reset*/
    private JButton getJButtonReset() {
        if (reset == null) {
            reset = new JButton();
            reset.setIcon(new ImageIcon("Figuras/reset.gif")); // NOI18N
            reset.addMouseListener(this);
            reset.addActionListener(this);

        }
        return reset;
    }

    /** Creates and returns the button New File*/
    private JButton getJButtonHome() {
        if (home == null) {
            home = new JButton();
            home.setIcon(new ImageIcon("Figuras/home.gif")); // NOI18N
            home.addMouseListener(this);
            home.addActionListener(this);

        }
        return home;
    }

    /** Creates and returns the Text Area Program*/
    private JTextArea getJTextProg() {
        if (txtProg == null) {
            txtProg = new JTextArea();
            txtProg.setColumns(20);
            txtProg.setRows(5);
            Font font = new Font("Monospaced", Font.LAYOUT_LEFT_TO_RIGHT, 12);
            txtProg.setFont(font);
            txtProg.setBorder(new NumeredBorder());
        }
        return txtProg;
    }

    /** Creates and returns the Text Area Console*/
    private JTextArea getJTextConsole() {
        if (txtConsole == null) {
            txtConsole = new JTextArea();
            txtConsole.setBackground(new java.awt.Color(240, 240, 240));
            txtConsole.setColumns(7);
            txtConsole.setRows(5);
        }
        return txtConsole;
    }

    /** Creates and returns the Scroll Pane Program*/
    private JScrollPane getJScrollPaneProg() {
        if (jScrollPane1 == null) {
            jScrollPane1 = new JScrollPane();
            jScrollPane1.setViewportView(getJTextProg());
        }
        return jScrollPane1;
    }

    /** Creates and returns the Scroll Pane Commmand*/
    private JScrollPane getJScrollPaneCmd() {
        if (jScrollPane2 == null) {
            jScrollPane2 = new JScrollPane();
            jScrollPane2.setViewportView(getJListCmd());
        }
        return jScrollPane2;
    }

    /** Creates and returns the Scroll Pane Console*/
    private JScrollPane getJScrollPaneConsole() {
        if (jScrollPane3 == null) {
            jScrollPane3 = new JScrollPane();
            jScrollPane3.setViewportView(getJTextConsole());

        }
        return jScrollPane3;
    }

    /** Creates and returns the Label Command*/
    private JLabel getJLabelCmd() {
        if (cmdTitle == null) {
            cmdTitle = new JLabel();
        }
        if (idioma.equals("Portugues")) {
            cmdTitle.setIcon(new ImageIcon("Figuras/comandos.gif"));
        } else {
            cmdTitle.setIcon(new ImageIcon("Figuras/commands.gif"));
        }
        return cmdTitle;
    }

    /** Creates and returns the List Command*/
    private JList getJListCmd() {
        if (cmdList == null) {
            cmdList = new JList();
            Font font = new Font("Courier", Font.BOLD, 12);
            cmdList.setFont(font);
            cmdList.setListData(strings_en);
            this.cmdList.addMouseListener(this);
        }
        return cmdList;
    }

    /* Returns the blockContext*/
    public BlockContext getBlockContext() {
        return blockContext;
    }

    /** Returns the Text Area Program*/
    public static JTextArea getTxtProgSave() {
        return JanelaPrograma.txtProg;
    }

    /** Set the Text Area Program*/
    public static void setTxtProgSave(String texto) {
        JanelaPrograma.txtProg.setText(texto);
    }

    /** Button events */
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == this.stepNext) { // Step Next Button
            if (blockContext == null || blockContext.isAlive() == false) {
                try {
                    if (blockContext == null) {
                        this.interpretProgram(new java.io.FileInputStream(createFileTemp()));
                    }
                    txtConsole.setText("");
                    txtProg.setEditable(false);
                    blockContext.executeNextInstruction();
                } catch (java.io.FileNotFoundException fe) {
                }
            } else {
                JOptionPane.showMessageDialog(null, getMessage(MES_EXE, ""));
            }
        } else if (e.getSource() == this.newFile) { // New File Button
            if (blockContext != null && blockContext.isAlive() == true) {
                JOptionPane.showMessageDialog(null, getMessage(MES_STOP, ""));
            } else {
                blockContext = null;
                txtProg.setText("");
                txtProg.setEditable(true);
            }
        } else if (e.getSource() == this.digitalWindow) { // Run Button
            jDigital.setLocation(tamanhoJanela.width - 930, tamanhoJanela.height - 340);
            jDigital.setVisible(true);
        } else if (e.getSource() == this.run) { // Run Button
            if (blockContext == null || blockContext.isAlive() == false) {
                try {
                    this.interpretProgram(new java.io.FileInputStream(createFileTemp()));
                    blockContext.inicializeProgram();
                    blockContext.start();
                } catch (java.io.FileNotFoundException fe) {
                }

            } else {
                JOptionPane.showMessageDialog(null, getMessage(MES_EXE, ""));
            }

        } else if ((e.getSource() == this.loop)) {
            if (blockContext == null || blockContext.isAlive() == false) {

                try {
                    this.interpretProgram(new java.io.FileInputStream(createFileTemp()));
                    blockContext.inicializeProgram();
                    blockContext.setExecutionLoop();
                    blockContext.start();

                } catch (java.io.FileNotFoundException fe) {
                }
            } else {
                JOptionPane.showMessageDialog(null, getMessage(MES_EXE, ""));
            }

        } else if (e.getSource() == this.stop) {
            if (blockContext != null) {
                blockContext.inicializeProgram();
                txtConsole.setText(txtConsole.getText() + getMessage(MES_STOPPED, ""));
                if (blockContext.isAlive() == true) {
                    blockContext.stop();
                }
            }
            blockContext = null;
            txtProg.setEditable(true);
        } else if (e.getSource() == this.reset) {
            if (blockContext != null) {
                if (blockContext.isAlive() == false) {
                    blockContext.inicializeProgram();
                    txtConsole.setText(getMessage(MES_RESET, ""));
                } else {
                    JOptionPane.showMessageDialog(null, getMessage(MES_EXE, ""));
                }
            }

        } else if (e.getSource() == this.home) {
            if (blockContext == null || blockContext.isAlive() == false) {
                this.cena.setMove(homePosition.getAngulos());
            } else {
                JOptionPane.showMessageDialog(null, getMessage(MES_EXE, ""));
            }


        } else if (e.getSource() == this.saveFile) {
            System.out.println("Salvando Arq");
            if (blockContext == null || blockContext.isAlive() == false) {
                if (salvaArquivo != null) {
                    if (salvaArquivo.isVisible()) {
                    } else {
                        System.out.println("Salvando Arq1");
                        salvaArquivo = new SalvaArquivo(cena, tamanhoJanela, "Salvar Programas");
                        salvaArquivo.setIdioma(cena.getJanelaPrincipal().getIdioma());
                    }
                } else {
                    System.out.println("Salvando Arq2");
                    salvaArquivo = new SalvaArquivo(cena, tamanhoJanela, "Salvar Programas");
                    salvaArquivo.setIdioma(cena.getJanelaPrincipal().getIdioma());
                }
            } else {
                JOptionPane.showMessageDialog(null, "Salvar Programas");
            }


        } else if (e.getSource() == this.openFile) {
            if (blockContext == null || blockContext.isAlive() == false) {
                if (salvaArquivo != null) {
                    if (salvaArquivo.isVisible()) {
                    } else {
                        salvaArquivo = new SalvaArquivo(cena, tamanhoJanela, "Carregar Programas");
                        salvaArquivo.setIdioma(cena.getJanelaPrincipal().getIdioma());
                    }
                } else {
                    salvaArquivo = new SalvaArquivo(cena, tamanhoJanela, "Carregar Programas");
                    salvaArquivo.setIdioma(cena.getJanelaPrincipal().getIdioma());
                }
            } else {
                JOptionPane.showMessageDialog(null, "Carregar Programas");
            }

        }
    }

    /** Create and Interpret the program*/
    private void interpretProgram(java.io.FileInputStream file) {
        try {
            txtConsole.setText("");
            Interpreter interp = new Interpreter(file);

            blockContext = new ScriptingBlockContext(null, this.cena);
            interp.ParseProgram(blockContext);

        } catch (ParseException pe) {
            pe.printStackTrace();
            /*Erros aparecem no console:
             * Inserir a linha abaixo na linha 130 da classe ParseException
             * JanelaPrograma.getTxtConsole().setText(JanelaPrograma.getTxtConsole().getText()+"\n"+retval);
             */

            System.out.println("ERRO: parser.");

        }

    }

    /* Create a temporary file of program and returns the name*/
    public String createFileTemp() {
        try {
            java.io.PrintWriter out = new java.io.PrintWriter(new java.io.FileWriter(new java.io.File("out")));
            out.println(txtProg.getText());
            out.close();
        } catch (java.io.IOException e) {
            JOptionPane.showMessageDialog(null, getMessage(MES_FNF, ""));
        }
        return "out";
    }

    /** Method ?*/
    private int verificaPontos(String nomePonto) {
        Integer numPontos = lPontos.getItemCount();
        Ponto ponto;
        for (int i = 0; i < numPontos; i++) {
            ponto = (Ponto) lPontos.getObjeto(i);
            if (nomePonto.equals(ponto.getNomePonto())) {
                return i;
            }
        }
        return -1;
    }

    /* Set language*/
    public void setIdioma(String idioma) {
        this.idioma = idioma;
        if (idioma.equals("Portugues")) {
            this.setTitle("Programação");
            cmdTitle.setIcon(new ImageIcon("Figuras/comandos.gif"));
            cmdList.setListData(strings_pt);
        }
        if (idioma.equals("Ingles")) {
            this.setTitle("Programming");
            cmdTitle.setIcon(new ImageIcon("Figuras/commands.gif"));
            cmdList.setListData(strings_en);
        }
    }

    /* Mouse events*/
    public void mouseClicked(MouseEvent e) {
        if (e.getClickCount() == 2) {

            if (cmdList.getSelectedIndex() == 1) { //OpenGripper
                txtProg.append("OG\n");
            } else if (cmdList.getSelectedIndex() == 2) { //CloseGripper
                txtProg.append("CG\n");
            } else if (cmdList.getSelectedIndex() == 3) {
                txtProg.append("GP [approach] #\n");
            } else if (cmdList.getSelectedIndex() == 4) {
                txtProg.append("GL [approach] #\n");
            } else if (cmdList.getSelectedIndex() == 5) {
                txtProg.append("GC [approach] #\n");
            } else if (cmdList.getSelectedIndex() == 6) {
                txtProg.append("GS [approach] #\n");
            } else if (cmdList.getSelectedIndex() == 7) {
                txtProg.append("JA #\n");
            } else if (cmdList.getSelectedIndex() == 8) {
                txtProg.append("IL [#|ALL] JU #\n");
            } else if (cmdList.getSelectedIndex() == 9) {
                txtProg.append("RP #\n");
            } else if (cmdList.getSelectedIndex() == 10) {
                txtProg.append("SA #\n");
            } else if (cmdList.getSelectedIndex() == 11) {
                txtProg.append("PH\n");
            } else if (cmdList.getSelectedIndex() == 12) {
                txtProg.append("SVS #\n");
            } else if (cmdList.getSelectedIndex() == 13) {
            } else if (cmdList.getSelectedIndex() == 14) {
                txtProg.append("WT #\n");
            } else if (cmdList.getSelectedIndex() == 15) {
                txtProg.append("JU #\n");
            } else if (cmdList.getSelectedIndex() == 16) {
                txtProg.append("RE #\n");
            } else if (cmdList.getSelectedIndex() == 17) {
                txtProg.append("RB\n");
            } else if (cmdList.getSelectedIndex() == 18) {
                txtProg.append("RT\n");
            } else if (cmdList.getSelectedIndex() == 19) {
                txtProg.append("SVC # = #\n");
            } else if (cmdList.getSelectedIndex() == 20) {
                txtProg.append("SVT #\n");
            } else if (cmdList.getSelectedIndex() == 21) {
                txtProg.append("IF # JU #\n");
            } else if (cmdList.getSelectedIndex() == 22) {
                txtProg.append("SS #\n");
            } else if (cmdList.getSelectedIndex() == 23) {
                txtProg.append("CS #\n");
            } else if (cmdList.getSelectedIndex() == 24) {
                txtProg.append("RS\n");
            } else if (cmdList.getSelectedIndex() == 25) {
                txtProg.append("#:\n");
            } else if (cmdList.getSelectedIndex() == 26) {
                txtProg.append("PS #\n");
            } else if (cmdList.getSelectedIndex() == 27) {
            } else if (cmdList.getSelectedIndex() == 28) {
                txtProg.append("II # [On|Off] [JU|CS] #\n");
            } else if (cmdList.getSelectedIndex() == 29) {
                txtProg.append("OI [#|ANY] [On|Off] [JU|CS] #\n");
            } else if (cmdList.getSelectedIndex() == 30) {
                txtProg.append("EI [#|ALL]\n");
            } else if (cmdList.getSelectedIndex() == 31) {
                txtProg.append("DI [#|ALL]\n");
            } else if (cmdList.getSelectedIndex() == 32) {
                txtProg.append("ON #\n");
            } else if (cmdList.getSelectedIndex() == 33) {
                txtProg.append("OF #\n");
            }
        }
    }

    /** Entered mouse*/
    public void mouseEntered(MouseEvent e) {
        if (e.getSource().equals(newFile)) {
            this.newFile.setToolTipText(getMessage(MES_NF, ""));
        } else if (e.getSource().equals(openFile)) {
            this.openFile.setToolTipText(getMessage(MES_OF, ""));
        } else if (e.getSource().equals(saveFile)) {
            this.saveFile.setToolTipText(getMessage(MES_SF, ""));
        } else if (e.getSource().equals(run)) {
            this.run.setToolTipText(getMessage(MES_RUN, ""));
        } else if (e.getSource().equals(loop)) {
            this.loop.setToolTipText(getMessage(MES_REPEAT, ""));
        } else if (e.getSource().equals(stop)) {
            this.stop.setToolTipText(getMessage(MES_STP, ""));
        } else if (e.getSource().equals(stepNext)) {
            this.stepNext.setToolTipText(getMessage(MES_STEP, ""));
        } else if (e.getSource().equals(reset)) {
            this.reset.setToolTipText(getMessage(MES_RESTART, ""));
        } else if (e.getSource().equals(home)) {
            this.home.setToolTipText(getMessage(MES_HOME, ""));
        } else if (e.getSource().equals(digitalWindow)) {
            this.digitalWindow.setToolTipText(getMessage(MES_DW, ""));
        }
    }

    public void mousePressed(MouseEvent e) {
        //throw new UnsupportedOperationException("Not supported yet.");
    }

    public void mouseReleased(MouseEvent e) {
        //throw new UnsupportedOperationException("Not supported yet.");
    }

    public void mouseExited(MouseEvent e) {
        //throw new UnsupportedOperationException("Not supported yet.");
    }

    /* Return Scene*/
    public CenaX3D getCena() {
        return this.cena;
    }

    /* Return Text Area Console*/
    public static JTextArea getTxtConsole() {
        return txtConsole;
    }

    public static String getIdioma() {
        return idioma;
    }
    /** Messages **/
    final static int MES_EXE = 1;
    final static int MES_STOP = 2;
    final static int MES_STOPPED = 3;
    final static int MES_RESET = 4;
    final static int MES_SAVE = 5;
    final static int MES_LOAD = 6;
    final static int MES_FNF = 7;
    final static int MES_NF = 8;
    final static int MES_OF = 9;
    final static int MES_SF = 10;
    final static int MES_RUN = 11;
    final static int MES_REPEAT = 12;
    final static int MES_STP = 13;
    final static int MES_RESTART = 14;
    final static int MES_NEXT = 15;
    final static int MES_STEP = 16;
    final static int MES_HOME = 17;
    final static int MES_DW = 18;

    /* JanelaPrograma's Messages */
    public String getMessage(int numberMessage, String complements) {
        String pt = "";
        String en = "";

        if (idioma.equals("Portugues") == false) {
            numberMessage += 100;
        }

        switch (numberMessage) {

            case MES_EXE:
                return pt + "Programa em execução!";
            case MES_EXE + 100:
                return en + "Executing program!";
            case MES_STOP:
                return pt + "Pressione Botão STOP!";
            case MES_STOP + 100:
                return en + "Push STOP button!";
            case MES_STOPPED:
                return pt + "Parado!";
            case MES_STOPPED + 100:
                return en + "Stopped!";
            case MES_RESET:
                return pt + "Inicio!";
            case MES_RESET + 100:
                return en + "Reset!";
            case MES_SAVE:
                return pt + "Salvar Programa!";
            case MES_SAVE + 100:
                return en + "Save Program!";
            case MES_LOAD:
                return pt + "Carregar Programa!";
            case MES_LOAD + 100:
                return en + "Load Program!";
            case MES_FNF:
                return pt + "Não foi possivel abrir o arquivo!";
            case MES_FNF + 100:
                return en + "It was not possible to open the file!";
            case MES_NF:
                return pt + "Novo Arquivo";
            case MES_NF + 100:
                return en + "New File";
            case MES_OF:
                return pt + "Abrir Arquivo";
            case MES_OF + 100:
                return en + "Open File";
            case MES_SF:
                return pt + "Salvar Arquivo";
            case MES_SF + 100:
                return en + "Save File";
            case MES_RUN:
                return pt + "Executar";
            case MES_RUN + 100:
                return en + "Run";
            case MES_REPEAT:
                return pt + "Repetir";
            case MES_REPEAT + 100:
                return en + "Repeat";
            case MES_STP:
                return pt + "Parar";
            case MES_STP + 100:
                return en + "Stop";
            case MES_RESTART:
                return pt + "Reiniciar";
            case MES_RESTART + 100:
                return en + "Reset";
            case MES_STEP:
                return pt + "Avançar Passo";
            case MES_STEP + 100:
                return en + "Next Step";
            case MES_HOME:
                return pt + "Posição Inicial";
            case MES_HOME + 100:
                return en + "Home";
            case MES_DW:
                return pt + "Janela Digital";
            case MES_DW + 100:
                return en + "Digital Window";
        }

        return "";
    }

    /* Used by compiler's command PH*/
    public static void setHomePosition(Ponto hPosition) {
        homePosition = hPosition;
    }

    public void executarPrograma() {
        throw new UnsupportedOperationException("Not yet implemented");
    }
} 

